
/****************************************************************************

dbExpress - Cross-Platform, database independent data access interface

Copyright (c) 2000, 2001 Borland Software Corporation

This file may be distributed and/or modified under the terms of the GNU
General Public License (GPL) version 2 as published by the Free Software

Software Foundation and appearing at
http://www.borland.com/kylix/gpl.html.

Licensees holding a valid Borland No-Nonsense License for this Software
may use this file in accordance with such license, which appears in the file
license.txt that came with this Software.

****************************************************************************/

#ifdef LINUX
#include <dlfcn.h>
#endif

#ifdef WINDOWS
#include <windows.h>
#endif

#include <stdio.h>
#include <dbxpress.h>
#include <sqlx.h>

////////////////////////////////////////////////////////////////////////////////

SQLResult getSQLDriver ( pCHAR pszName, pCHAR pszDriverLib, pCHAR pszVendorLib, ppSQLDriver ppDrvr)
{
  SQLResult retcode = SQL_SUCCESS;
  SQLResult (*pfn) (pCHAR, pCHAR, ppSQLDriver ) = NULL;

  #ifdef LINUX
  pVOID hdll = NULL;
  #endif

  #ifdef WINDOWS
  HMODULE hdll = NULL;
  #endif

  if ( ppDrvr )
     *ppDrvr = NULL;

  #ifdef LINUX
  hdll = dlopen( pszDriverLib, RTLD_NOW);
  #endif

  #ifdef WINDOWS
  hdll = LoadLibrary( pszDriverLib);
  #endif
  
  if ( hdll )
  {
     #ifdef LINUX
     pfn = ( long (*) (pCHAR, pCHAR, ppSQLDriver) ) dlsym( hdll, "allocateSQLDriver");
     #endif

     #ifdef WINDOWS
     pfn = ( long (*) (pCHAR, pCHAR, ppSQLDriver) )GetProcAddress( hdll, "allocateSQLDriver");
     #endif
    
     if ( pfn )
        retcode = (*pfn) ( pszName, pszVendorLib, ppDrvr );
     else
        retcode = SQLX_INITFAIL;
  } 
  else
     retcode = SQLX_INITFAIL;

  return retcode;

}

////////////////////////////////////////////////////////////////////////////////
