
/****************************************************************************

dbExpress - Cross-Platform, database independent data access interface

Copyright (c) 2000, 2001 Borland Software Corporation

This file may be distributed and/or modified under the terms of the GNU
General Public License (GPL) version 2 as published by the Free Software

Software Foundation and appearing at
http://www.borland.com/kylix/gpl.html.

Licensees holding a valid Borland No-Nonsense License for this Software
may use this file in accordance with such license, which appears in the file
license.txt that came with this Software.

****************************************************************************/

#include <dbxpress.h>
#include <dbxtypes.h>
#include <schconst.h>
#include <string.h>
#include <stdio.h>

void GetCommandError( pSQLCommand pCommand, pCHAR * ppszErrorMessage )
{
   UINT16 iLen;
   pCHAR pszErrorMsg;
   SQLResult rslt = pCommand->getErrorMessageLen( &iLen );
   if( !rslt && iLen )
   {
      pszErrorMsg = new CHAR[ iLen + 1 ];
      rslt = pCommand->getErrorMessage( (pBYTE) pszErrorMsg );
      if( !rslt )
      {
         if( *ppszErrorMessage )
            delete [] *ppszErrorMessage;
         pszErrorMsg[ iLen ] = 0;
         *ppszErrorMessage = pszErrorMsg;  // destructor will delete
      }
      else
         delete [] pszErrorMsg;
   }
}

eAddToQueryType AddToQuery( pCHAR * ppszQuery, pCHAR pszToAdd, eAddToQueryType eType )
{
   pCHAR pszNewQuery;  // initialized below: default in else ...
   if( eType == eAddTypeNone )
   {
      pszNewQuery = new CHAR[ strlen( *ppszQuery ) + strlen( pszToAdd ) + 1 ];
      sprintf( pszNewQuery, "%s%s", *ppszQuery, pszToAdd );
   }
   else if( eType == eAddTypeAnd )
   {
      char * szAnd = " AND ";
      pszNewQuery = new CHAR[ strlen( *ppszQuery ) + strlen( pszToAdd ) + strlen( szAnd ) + 1 ];
      sprintf( pszNewQuery, "%s%s%s", *ppszQuery, szAnd, pszToAdd );
   }
   else if( eType == eAddTypeWhere )
   {
      char * szWhere = " WHERE ";
      pszNewQuery = new CHAR[ strlen( *ppszQuery ) + strlen( pszToAdd ) + strlen( szWhere ) + 1 ];
      sprintf( pszNewQuery, "%s%s%s", *ppszQuery, szWhere, pszToAdd );
   }
   else // eType == eAddTypeOr
   {
      char * szOr = " OR ";
      pszNewQuery = new CHAR[ strlen( *ppszQuery ) + strlen( pszToAdd ) + strlen( szOr ) + 1 ];
      sprintf( pszNewQuery, "%s%s%s", *ppszQuery, szOr, pszToAdd );
   }
   delete [] *ppszQuery;
   *ppszQuery = pszNewQuery;
   return eAddTypeAnd;         // to know that query contains 'where'
}

void AddFilter( pCHAR * ppszBase, pCHAR pszSourceFilter,
                                   pCHAR pszInsert, eAddToQueryType eAddType )
{
      pCHAR pszFilter = new CHAR[ strlen( pszSourceFilter ) + strlen( pszInsert ) + 1 ];
      sprintf( pszFilter, pszSourceFilter, pszInsert );
      AddToQuery( ppszBase, pszFilter, eAddType );
      delete [] pszFilter;
}


INT32 GetStandardColLengthFromAction( eGetColumnAction eAction, BOOL bPrecision, UINT16 uColumnNumber )
{
   INT32 iRetval = -1;
   switch( eAction )
   {
      case eGetRecno:
      case eCalcType:
      case eCalcLength:  
      case eCalcNullable:
         iRetval = bPrecision ? 0 : sizeof( INT32 );
         break;
      case eCalcDataType:
      case eCalcSubtype:
      case eCalcPrecision:
      case eCalcScale:
         iRetval = bPrecision ? 0 : sizeof( INT16 );
         break;
      case eUseNullString:
         iRetval = (UINT32) (strlen( NULLSTRING ) + 1 ); 
         break;
      case eCalcAscDesc:
         iRetval = (UINT32) strlen( ASCENDING ) + 1;
         break;
   }
   return iRetval;
}


