
/****************************************************************************

dbExpress - Cross-Platform, database independent data access interface

Copyright (c) 2000, 2001 Borland Software Corporation

This file may be distributed and/or modified under the terms of the GNU
General Public License (GPL) version 2 as published by the Free Software

Software Foundation and appearing at
http://www.borland.com/kylix/gpl.html.

Licensees holding a valid Borland No-Nonsense License for this Software
may use this file in accordance with such license, which appears in the file
license.txt that came with this Software.

****************************************************************************/

#ifndef MYS_SCHEMACONST_H
   #define MYS_SCHEMACONST_H
#include <schconst.h>
// 10 + 6 for digits and 2 for parentheses
#define MYSMAXTYPENAME_SIZE    18  
// todo: find real value
#define MYSPRIMARY          "PRIMARY"
#define MYSNULLABLEString   "Y"
#define MYSMAXNAMELEN          30
#define MYSMAXCOLUMNLENGTH     62
#define MYSTablesQuery "SHOW TABLES"
#define MYSNameCol          1
#define MYSColumnsQuery "SHOW COLUMNS FROM %s"
#define MYSFieldTypeCol     2
#define MYSNullableCol      3
#define MYSDefaultCol       5
#define MYSExtra            6
#define MYSAutoInc       "auto_increment"
#define MYSIndexesForTableQuery "SHOW INDEX FROM %s"
#define MYSNonUniqueCol     2
#define MYSIndexNameCol     3
#define MYSIndexOrderCol    4
#define MYSIndexColNameCol  5
#define MYSColAscDescCol    6
#define MYSPatternFilter " LIKE '%s'"
#define MYSDBObject "SHOW DATABASES"
#define MYSUser "SELECT DISTINCT USER FROM USER ORDER BY USER"
#define MAXRECSIZEQUERY "SHOW VARIABLES LIKE 'record_buffer'"
const pCHAR ExtendedObjectQuery[] = 
                          { "",
                            "",
                            MYSTablesQuery,
                            "",
                            "",
                            "",
                            "",
                            "",
                            "",
                            MYSColumnsQuery,
                            "",
                            MYSIndexesForTableQuery };
const pCHAR ObjectQuery[] = 
                          { MYSDBObject, 
                            "",
                            MYSTablesQuery,
                            "",
                            "",
                            "",
                            MYSUser,
                            "",
                            "" };


const eGetColumnAction ObjAction[] = { eGetRecno, eUseNullString, eUseNullString, eGetFromServer };
const eGetColumnAction TblObjAction[] = { eGetRecno, eCalcDatabase, eUseNullString, eGetFromServer, eCalcType };
const eGetColumnAction ColObjAction[] = { eGetRecno, eCalcDatabase, eUseNullString, eUseParamName, eGetFromServer, eCalcColPosition, eCalcType, eCalcTypeInfo, eCalcDataTypeName, eCalcTypeInfo, eCalcTypeInfo, eCalcTypeInfo, eCalcTypeInfo, eGetFromServer };
const eGetColumnAction IdxObjAction[] = { eGetRecno, eCalcDatabase, eUseNullString, eUseParamName, eGetFromServer, eGetFromServer, eGetFromServer, eUseNullString, eCalcType, eGetFromServer, eUseNullString };

const eGetColumnAction * ColumnActionType[] =
                         { ObjAction,
                           ObjAction,
                           TblObjAction,
                           NULL,
                           NULL,
                           NULL,
                           ObjAction,
                           ObjAction,
                           ObjAction,
                           ColObjAction,
                           NULL,
                           IdxObjAction };


#define MaxLkUpFldTypes           28
const pCHAR LkUpFldTypeNames[] = {
                                 "BIGINT",
                                 "BLOB",
                                 "TEXT",
                                 "CHAR",
                                 "DATE",
                                 "DATETIME",
                                 "DECIMAL",
                                 "DOUBLE",
                                 "ENUM",
                                 "FLOAT",
                                 "INT",
                                 "LONGBLOB",
                                 "LONGTEXT",
                                 "MEDIUMINT",
                                 "NUMERIC",
                                 "REAL",
                                 "SET",
                                 "SMALLINT",
                                 "TEXTBLOB",
                                 "TIME",
                                 "TIMESTAMP",
                                 "TINYINT",
                                 "VARCHAR",
                                 "YEAR",
                                 "TINYBLOB",
                                 "TINYTEXT",
                                 "MEDIUMBLOB",
                                 "MEDIUMTEXT" };

// This will be replaced by generic getLogicalColumnInfo()
const INT16 LkUpFldLogType[] = {
                              fldFLOAT,
                              fldBLOB,
                              fldBLOB,
                              fldZSTRING,
                              fldDATE,
                              fldDATETIME,
                              fldBCD,
                              fldFLOAT,
                              fldBYTES,
                              fldFLOAT,
                              fldINT32,
                              fldBLOB,
                              fldBLOB,
                              fldINT32,
                              fldBCD,
                              fldFLOAT,
                              fldBYTES,
                              fldINT16,
                              fldBLOB,
                              fldTIME,
                              fldDATETIME, 
                              fldINT16,
                              fldZSTRING,
                              fldINT16,
                              fldBLOB,
                              fldBLOB,
                              fldBLOB,
                              fldBLOB };    

const INT16 LkUpFldSubType[] = {
                              0,
                              fldstBINARY,
                              fldstMEMO,
                              fldstFIXED,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              fldstBINARY,
                              fldstMEMO,
                              0,
                              0,
                              0,
                              0,
                              0,
                              fldstMEMO,
                              0,
                              0, 
                              0, 
                              0,
                              0,
                              fldstBINARY,
                              fldstMEMO,   
                              fldstBINARY,
                              fldstMEMO };   

const INT32 LkUpFldLength[] = {
                              sizeof( DFLOAT ),
                              0,
                              0,
                              -1,
                              sizeof( DBIDATE ),
                              sizeof( CTIMESTAMP ),
                              sizeof( FMTBcd ),
                              sizeof( DFLOAT ),
                              -1,
                              sizeof( DFLOAT ),
                              sizeof( INT32 ),
                              0,
                              0,
                              sizeof( INT32 ),
                              sizeof( FMTBcd ),
                              sizeof( DFLOAT ),
                              -1,
                              sizeof( INT16 ),
                              0,
                              sizeof( TIME ),
                              sizeof( CTIMESTAMP ),
                              sizeof( INT16 ),
                              -1,
                              sizeof( INT16 ),
                              0,
                              0,
                              0,
                              0 };   

const INT16 LkUpFldPrecision[] = {
                              0,
                              0,
                              0,
                              -1,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              -1,
                              0,
                              0,
                              0,   
                              0,
                              0 };   
const INT16 LkUpFldScale[] = {
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,
                              0,   
                              0,
                              0 };   
#endif
