
/****************************************************************************

dbExpress - Cross-Platform, database independent data access interface

Copyright (c) 2000, 2001 Borland Software Corporation

This file may be distributed and/or modified under the terms of the GNU
General Public License (GPL) version 2 as published by the Free Software

Software Foundation and appearing at
http://www.borland.com/kylix/gpl.html.

Licensees holding a valid Borland No-Nonsense License for this Software
may use this file in accordance with such license, which appears in the file
license.txt that came with this Software.

****************************************************************************/

#ifndef INTLRC_H
#define INTLRC_H

#define RB_BASE   0x100


#define  iRBKEYVIOL             ( RB_BASE + 0 )
#define  iRBPROBLEMS            ( RB_BASE + 1 )
#define  iRBCHANGED              ( RB_BASE + 2 )

#define  szRBKEYVIOL             "KEYVIOL"
#define  szRBPROBLEMS            "PROBLEMS"
#define  szRBCHANGED             "CHANGED"


// XB = xbase
#define XB_BASE   0x200

// MDX missing or corrupt
#define  iXBMDXENTRYNUMS         3
#define  iXBMDXDEFAULT           1
#define  iXBDBTENTRYNUMS         3
#define  iXBDBTDEFAULT           1

#define  iXBMDXMSG               ( XB_BASE + 0x0 )
#define  iXBMDXLANGMSG           ( XB_BASE + 0x14 )
#define  iXBMDXDAMAGEDMSG        ( XB_BASE + 0x15 )

#define  iXBMDXOPENRO            ( XB_BASE + 0x1 )
#define  iXBMDXOPENROHELP        ( XB_BASE + 0x2 )
#define  iXBMDXOPENDETACH        ( XB_BASE + 0x3 )
#define  iXBMDXOPENDETACHHELP    ( XB_BASE + 0x4 )
#define  iXBMDXFAILOPEN          ( XB_BASE + 0x5 )
#define  iXBMDXFAILOPENHELP      ( XB_BASE + 0x6 )
#define  iXBFOXREGEN             ( XB_BASE + 0x7 )
#define  iXBFOXREGENHELP         ( XB_BASE + 0x8 )
#define  iXBMDXREGEN             ( XB_BASE + 0x16 )
#define  iXBMDXREGENHELP         ( XB_BASE + 0x17 )

#define  iXBDBTMSG               ( XB_BASE + 0x9 )
#define  iXBDBTOPNOMEMO          ( XB_BASE + 0xa )
#define  iXBDBTOPNOMEMOHELP      ( XB_BASE + 0xb )
#define  iXBDBTREINITBLOB        ( XB_BASE + 0xc )
#define  iXBDBTREINITBLOBHELP    ( XB_BASE + 0xd )
#define  iXBDBTFAILOPEN          ( XB_BASE + 0xe )
#define  iXBDBTFAILOPENHELP      ( XB_BASE + 0xf )
#define  iXBDBTIMPORT            ( XB_BASE + 0x10 )
#define  iXBDBTIMPORTHELP        ( XB_BASE + 0x11 )
#define  iXBDBTOPNNODBASE        ( XB_BASE + 0x12 )
#define  iXBDBTOPNNODBASEHELP    ( XB_BASE + 0x13 )

#define  szXBMDXMSG              "Production Index file missing, corrupt or cannot interpret index key"
#define  szXBMDXLANGMSG          "Production Index Language driver mismatch"
#define  szXBMDXDAMAGEDMSG       "Production Index damaged"
#define  szXBMDXOPENRO           "Open Read Only"
#define  szXBMDXOPENROHELP       "Open the table in read only mode"
#define  szXBMDXOPENDETACH       "Open and Detach"
#define  szXBMDXOPENDETACHHELP   "Open the table and detach the Production Index file"
#define  szXBMDXFAILOPEN         "Fail Open"
#define  szXBMDXFAILOPENHELP     "Do not open the table"
#define  szXBFOXREGEN            "Convert Non-dBase Index"
#define  szXBFOXREGENHELP        "Convert production index to dBase format"
#define  szXBMDXREGEN            "Rebuild Production Index"
#define  szXBMDXREGENHELP        "Rebuild all the Production Indexes"

#define  szXBDBTMSG              "BLOB file not found"
#define  szXBDBTOPNOMEMO         "Open without blob file"
#define  szXBDBTOPNOMEMOHELP     "Open the table without the blob file"
#define  szXBDBTREINITBLOB       "Empty all blob fields"
#define  szXBDBTREINITBLOBHELP   "Reinitialize BLOB file and LOSE all blobs"
#define  szXBDBTFAILOPEN         "Fail Open"
#define  szXBDBTFAILOPENHELP     "Do not open the table"
#define  szXBDBTIMPORT           "Import Non-dBASE BLOB file"
#define  szXBDBTIMPORTHELP       "Import BLOB file to dBASE format"
#define  szXBDBTOPNNODBASE       "Open as Non-dBASE table"
#define  szXBDBTOPNNODBASEHELP   "Open Table and BLOB file in its native format"

// Referential Link missing or corrupt
#define  iXBRINTENTRYNUMS        4
#define  iXBRINTDEFAULT          1

#define  iXBRINTMSG               ( XB_BASE + 0x18 )
#define  iXBRINTTBLNOTFOUND       ( XB_BASE + 0x19 )
#define  iXBRINTIDXNOTFOUND       ( XB_BASE + 0x1a )
#define  iXBRINTINVALID           ( XB_BASE + 0x1b )

#define  iXBRINTOPENRO            ( XB_BASE + 0x1c )
#define  iXBRINTOPENROHELP        ( XB_BASE + 0x1d )
#define  iXBRINTFAILOPEN          ( XB_BASE + 0x1e )
#define  iXBRINTFAILOPENHELP      ( XB_BASE + 0x1f )
#define  iXBRINTIGNORE            ( XB_BASE + 0x20 )
#define  iXBRINTIGNOREHELP        ( XB_BASE + 0x21 )
#define  iXBRINTREMOVE            ( XB_BASE + 0x22 )
#define  iXBRINTREMOVEHELP        ( XB_BASE + 0x23 )

#define  szXBRINTMSG              "Referential Integrity Linked Table or Index missing or corrupt"
#define  szXBRINTTBLNOTFOUND      "Linked Table missing"
#define  szXBRINTIDXNOTFOUND      "Linked Index missing or corrupt"
#define  szXBRINTINVALID          "Referential Integrity Link corrupt"

#define  szXBRINTOPENRO           "Open Read Only"
#define  szXBRINTOPENROHELP       "Open the table in read only mode"
#define  szXBRINTFAILOPEN         "Fail Open"
#define  szXBRINTFAILOPENHELP     "Do not open the table"
#define  szXBRINTIGNORE           "Ignore Link"    
#define  szXBRINTIGNOREHELP       "Ignore This Referential Integrity Link"
#define  szXBRINTREMOVE           "Remove Links"
#define  szXBRINTREMOVEHELP       "Remove All Referential Integrity Links"

// PDX = paradox
#define PDX_BASE   0x400

// lookuptable/blob/valfile missing or corrupt
#define  iPDXENTRYNUMS           2
// fail as default!
#define  iPDXDEFAULT             2

#define  iPDXMSGLOOKUP           ( PDX_BASE + 0 )
#define  iPDXMSGBLOB             ( PDX_BASE + 1 )
#define  iPDXMSGOPENRDONLY       ( PDX_BASE + 2 )
#define  iPDXHELPRDONLY          ( PDX_BASE + 3 )
#define  iPDXMSGFAIL             ( PDX_BASE + 4 )
#define  iPDXHELPFAIL            ( PDX_BASE + 5 )
#define  iPDXMSGREMOVELINK       ( PDX_BASE + 6 )
#define  iPDXHELPREMOVELINK      ( PDX_BASE + 7 )

#define  szPDXMSGLOOKUP          "Lookup table not found or corrupt"
#define  szPDXMSGBLOB            "Blob file not found or corrupt"
#define  szPDXMSGOPENRDONLY      "Open Read Only"
#define  szPDXHELPRDONLY         "Open the table in read only mode"
#define  szPDXMSGFAIL            "Fail Open"
#define  szPDXHELPFAIL           "Do not open the table"
#define  szPDXMSGREMOVELINK      "Remove lookup"
#define  szPDXHELPREMOVELINK     "Remove link to lookup table"


// Data Repository - Callbacks, etc.

#define DR_BASE   0x500

#define  iDROBJEXISTSMSG         ( DR_BASE + 0 )
#define  iDRSKIPOBJECT           ( DR_BASE + 1 )
#define  iDRSKIPOBJECTHELP       ( DR_BASE + 2 )
#define  iDRUSEEXISTOBJ          ( DR_BASE + 3 )
#define  iDRUSEEXISTOBJHELP      ( DR_BASE + 4 )
#define  iDRABORT                ( DR_BASE + 5 )
#define  iDRABORTHELP            ( DR_BASE + 6 )
#define  iDROBJIMPFAILMSG        ( DR_BASE + 7 )

#define  szDROBJEXISTS           "Dictionary Object Exists - "
#define  szDROBJIMPFAILMSG       "Dictionary Object Import Failed - "
#define  szDRSKIPOBJECT          "Skip this Object"
#define  szDRSKIPOBJECTHELP      "Skip Importing this Object and its associated Relationships"
#define  szDRUSEEXISTOBJ         "Use Existing Object"
#define  szDRUSEEXISTOBJHELP     "Use Existing Dictionary Object for Relationships"
#define  szDRABORT               "Abort"
#define  szDRABORTHELP           "Abort the operation"

// Progress callbacks

#define PRG_BASE  0x800

#define  iPRGREADRECS           ( PRG_BASE + 0 )
#define  iPRGSORTRECS           ( PRG_BASE + 1 )
#define  iPRGWRITERECS          ( PRG_BASE + 2 )
#define  iPRGMERGERECS          ( PRG_BASE + 3 )
#define  iPRGSTEPSCOMPLETE      ( PRG_BASE + 4 )
#define  iPRGPACKRECS           ( PRG_BASE + 5 )

#define  szPRGREADRECS         "Reading records"
#define  szPRGSORTRECS         "Sorting records"
#define  szPRGWRITERECS        "Writing records"
#define  szPRGMERGERECS        "Merging"
#define  szPRGSTEPCOMPLETE     "Steps Completed"
#define  szPRGPACKRECS         "Packing records"


#define QRY_KEYWORD_BASE       0x900
// Query DLL reserves strings from 0x900 to 0x1100


// this is the set of bit masks in use to put/get info out of the ulDBASE
// element of the SESSION structure.  Here are the bits now in use:
//
//      31               16 15                0
//      |                 | |                 |
//      0000 0000 0000 0000 0000 RRRD DDPP DDDD
//

// D = dbase
#define XBMDXSAVE    0x00000004            //Save bit for MDX action
#define XBMDXACTION  0x00000003            //2 bits to store 4 choices
#define XBDBTSAVE    0x00000008            //Save bit for DBT Action
#define XBDBTACTION  0x000001C0            //Need 3 bits to store 5 choices
#define XBRINTSAVE   0x00000800            //Save bit for RINT action
#define XBRINTACTION 0x00000600            //2 bits to store 4 choices

// P = paradox
#define PDXMISSSAVE 0x00000010
#define PDXMISSOPEN 0x00000020

// R = Repository
#define DRSAVE      0x00000800            //Save bit for Repository Action
#define DRACTION    0x00000600            //Need 2 bits to store 3 choices

// ST = SQL Trace
#define ST_BASE   0x1200

#define iST_UNKNOWN        ( ST_BASE + 0 )
#define iST_QPREPARE       ( ST_BASE + 1 )
#define iST_QEXECUTE       ( ST_BASE + 2 )
#define iST_ERROR          ( ST_BASE + 3 )
#define iST_STMT           ( ST_BASE + 4 )
#define iST_CONNECT        ( ST_BASE + 5 )
#define iST_TRANSACT       ( ST_BASE + 6 )
#define iST_BLOB           ( ST_BASE + 7 )
#define iST_MISC           ( ST_BASE + 8 )
#define iST_VENDOR         ( ST_BASE + 9 )

#define szST_UNKNOWN       "SQL UNKNOWN"
#define szST_QPREPARE      "SQL Prepare"
#define szST_QEXECUTE      "SQL Execute"
#define szST_ERROR         "SQL Error"
#define szST_STMT          "SQL Stmt"
#define szST_CONNECT       "SQL Connect"
#define szST_TRANSACT      "SQL Transact"
#define szST_BLOB          "SQL Blob IO"
#define szST_MISC          "SQL Misc"
#define szST_VENDOR        "SQL Vendor"

// ORACLE VENDOR CALLS

#define iST_ORLON          (ST_BASE + 10)
#define iST_OLON           (ST_BASE + 11)
#define iST_OLOGOF         (ST_BASE + 12)
#define iST_OCON           (ST_BASE + 13)
#define iST_OCOF           (ST_BASE + 14)
#define iST_OOPEN          (ST_BASE + 15)
#define iST_OSQL3          (ST_BASE + 16)
#define iST_ODSC           (ST_BASE + 17)
#define iST_ODEFIN         (ST_BASE + 18)
#define iST_OBNDRV         (ST_BASE + 19)
#define iST_OBNDRN         (ST_BASE + 20)
#define iST_OEXEC          (ST_BASE + 21)
#define iST_OFETCH         (ST_BASE + 22)
#define iST_OFEN           (ST_BASE + 23)
#define iST_OCAN           (ST_BASE + 24)
#define iST_OCLOSE         (ST_BASE + 25)
#define iST_OERHMS         (ST_BASE + 26)
#define iST_OPARSE         (ST_BASE + 27)
#define iST_OFLNG          (ST_BASE + 28)
#define iST_ODESSP         (ST_BASE + 29)
#define iST_ODESCR         (ST_BASE + 30)
#define iST_OEXN           (ST_BASE + 31)

#define szST_ORLON         "ORACLE - orlon"
#define szST_OLON          "ORACLE - olon"
#define szST_OLOGOF        "ORACLE - ologof"
#define szST_OCON          "ORACLE - ocon"
#define szST_OCOF          "ORACLE - ocof"
#define szST_OOPEN         "ORACLE - oopen"
#define szST_OSQL3         "ORACLE - osql3"
#define szST_ODSC          "ORACLE - odsc"
#define szST_ODEFIN        "ORACLE - odefin"
#define szST_OBNDRV        "ORACLE - obndrv"
#define szST_OBNDRN        "ORACLE - obndrvn"
#define szST_OEXEC         "ORACLE - oexec"
#define szST_OFETCH        "ORACLE - ofetch"
#define szST_OFEN          "ORACLE - ofen"
#define szST_OCAN          "ORACLE - ocan"
#define szST_OCLOSE        "ORACLE - oclose"
#define szST_OERHMS        "ORACLE - oerhms"
#define szST_OPARSE        "ORACLE - oparse"
#define szST_OFLNG         "ORACLE - oflng"
#define szST_ODESSP        "ORACLE - odessp"
#define szST_ODESCR        "ORACLE - odescr"
#define szST_OEXN          "ORACLE - oexn"
 
// INTERBASE VENDOR CALLS

#define iST_isc_attach_database           (ST_BASE + 40)
#define iST_isc_blob_default_desc         (ST_BASE + 41)
#define iST_isc_blob_gen_bpb              (ST_BASE + 42)
#define iST_isc_blob_info                 (ST_BASE + 43)
#define iST_isc_blob_lookup_desc          (ST_BASE + 44)
#define iST_isc_close_blob                (ST_BASE + 45)
#define iST_isc_commit_retaining          (ST_BASE + 46)
#define iST_isc_commit_transaction        (ST_BASE + 47)
#define iST_isc_create_blob               (ST_BASE + 48)
#define iST_isc_create_blob2              (ST_BASE + 49)
#define iST_isc_decode_date               (ST_BASE + 50)
#define iST_isc_detach_database           (ST_BASE + 51)
#define iST_isc_dsql_allocate_statement   (ST_BASE + 52)
#define iST_isc_dsql_execute              (ST_BASE + 53)
#define iST_isc_dsql_execute2             (ST_BASE + 54)
#define iST_isc_dsql_fetch                (ST_BASE + 55)
#define iST_isc_dsql_free_statement       (ST_BASE + 56)
#define iST_isc_dsql_prepare              (ST_BASE + 57)
#define iST_isc_dsql_set_cursor_name      (ST_BASE + 58)
#define iST_isc_dsql_sql_info             (ST_BASE + 59)
#define iST_isc_encode_date               (ST_BASE + 60)
#define iST_isc_get_segment               (ST_BASE + 61)
#define iST_isc_interprete                (ST_BASE + 62)
#define iST_isc_open_blob                 (ST_BASE + 63)
#define iST_isc_open_blob2                (ST_BASE + 64)
#define iST_isc_put_segment               (ST_BASE + 65)
#define iST_isc_rollback_transaction      (ST_BASE + 66)
#define iST_isc_sqlcode                   (ST_BASE + 67)
#define iST_isc_start_transaction         (ST_BASE + 68)
#define iST_isc_vax_integer               (ST_BASE + 69)

#define szST_isc_attach_database          "INTRBASE - isc_attach_database"
#define szST_isc_blob_default_desc        "INTRBASE - isc_blob_default_desc"
#define szST_isc_blob_gen_bpb             "INTRBASE - isc_blob_gen_bpb"
#define szST_isc_blob_info                "INTRBASE - isc_blob_info"
#define szST_isc_blob_lookup_desc         "INTRBASE - isc_blob_lookup_desc"
#define szST_isc_close_blob               "INTRBASE - isc_close_blob"
#define szST_isc_commit_retaining         "INTRBASE - isc_commit_retaining"
#define szST_isc_commit_transaction       "INTRBASE - isc_commit_transaction"
#define szST_isc_create_blob              "INTRBASE - isc_create_blob"
#define szST_isc_create_blob2             "INTRBASE - isc_create_blob2"
#define szST_isc_decode_date              "INTRBASE - isc_decode_date"
#define szST_isc_detach_database          "INTRBASE - isc_detach_database"
#define szST_isc_dsql_allocate_statement  "INTRBASE - isc_dsql_allocate_statement"
#define szST_isc_dsql_execute             "INTRBASE - isc_dsql_execute"
#define szST_isc_dsql_execute2            "INTRBASE - isc_dsql_execute2"
#define szST_isc_dsql_fetch               "INTRBASE - isc_dsql_fetch"
#define szST_isc_dsql_free_statement      "INTRBASE - isc_dsql_free_statement"
#define szST_isc_dsql_prepare             "INTRBASE - isc_dsql_prepare"
#define szST_isc_dsql_set_cursor_name     "INTRBASE - isc_dsql_set_cursor_name"
#define szST_isc_dsql_sql_info            "INTRBASE - isc_dsql_sql_info"
#define szST_isc_encode_date              "INTRBASE - isc_encode_date"
#define szST_isc_get_segment              "INTRBASE - isc_get_segment"
#define szST_isc_interprete               "INTRBASE - isc_interprete"
#define szST_isc_open_blob                "INTRBASE - isc_open_blob"
#define szST_isc_open_blob2               "INTRBASE - isc_open_blob2"
#define szST_isc_put_segment              "INTRBASE - isc_put_segment"
#define szST_isc_rollback_transaction     "INTRBASE - isc_rollback_transaction"
#define szST_isc_sqlcode                  "INTRBASE - isc_sqlcode"
#define szST_isc_start_transaction        "INTRBASE - isc_start_transaction"
#define szST_isc_vax_integer              "INTRBASE - isc_vax_integer"

// MICROSOFT SQL SERVER VENDOR CALLS
 
#define iST_dbbind                        (ST_BASE + 80)
#define iST_dbcmd                         (ST_BASE + 81)
#define iST_dbcancel                      (ST_BASE + 82)
#define iST_dbclose                       (ST_BASE + 83)
#define iST_dbcollen                      (ST_BASE + 84)
#define iST_dbcolname                     (ST_BASE + 85)
#define iST_dbcoltype                     (ST_BASE + 86)
#define iST_dbconvert                     (ST_BASE + 87)
#define iST_dbdataready                   (ST_BASE + 88)
#define iST_dbdatlen                      (ST_BASE + 89)
#define iST_dberrhandle                   (ST_BASE + 90)
#define iST_dbfreebuf                     (ST_BASE + 91)
#define iST_dbfreelogin                   (ST_BASE + 92)
#define iST_dbhasretstat                  (ST_BASE + 93)
#define iST_dbinit                        (ST_BASE + 94)
#define iST_dblogin                       (ST_BASE + 95)
#define iST_dbmoretext                    (ST_BASE + 96)
#define iST_dbmsghandle                   (ST_BASE + 97)
#define iST_dbnextrow                     (ST_BASE + 98)
#define iST_dbnumcols                     (ST_BASE + 99)
#define iST_dbnumrets                     (ST_BASE + 100)
#define iST_dbopen                        (ST_BASE + 101)
#define iST_dbresults                     (ST_BASE + 102)
#define iST_dbretdata                     (ST_BASE + 103)
#define iST_dbretlen                      (ST_BASE + 104)
#define iST_dbretstatus                   (ST_BASE + 105)
#define iST_dbrpcinit                     (ST_BASE + 106)
#define iST_dbrpcparam                    (ST_BASE + 107)
#define iST_dbrpcsend                     (ST_BASE + 108)
#define iST_dbsetlogintime                (ST_BASE + 109)
#define iST_dbsetmaxprocs                 (ST_BASE + 110)
#define iST_dbsetopt                      (ST_BASE + 111)
#define iST_dbsettime                     (ST_BASE + 112)
#define iST_dbsqlexec                     (ST_BASE + 113)
#define iST_dbsqlok                       (ST_BASE + 114)
#define iST_dbsqlsend                     (ST_BASE + 115)
#define iST_dbtxptr                       (ST_BASE + 116)
#define iST_dbtxtimestamp                 (ST_BASE + 117)
#define iST_dbtxtsnewval                  (ST_BASE + 118)
#define iST_dbuse                         (ST_BASE + 119)
#define iST_dbwinexit                     (ST_BASE + 120)
#define iST_dbwritetext                   (ST_BASE + 121)
#define iST_dbdead                        (ST_BASE + 122)
#define iST_dbcount                       (ST_BASE + 123)
#define iST_dbcolinfo                     (ST_BASE + 124)
#define iST_dbrpcexec                     (ST_BASE + 125)
#define iST_dbcanquery                    (ST_BASE + 126)
 
#define szST_dbbind                       "MSSQL - dbbind"
#define szST_dbcmd                        "MSSQL - dbcmd"
#define szST_dbcancel                     "MSSQL - dbcancel"
#define szST_dbclose                      "MSSQL - dbclose"
#define szST_dbcollen                     "MSSQL - dbcollen"
#define szST_dbcolname                    "MSSQL - dbcolname"
#define szST_dbcoltype                    "MSSQL - dbcoltype"
#define szST_dbconvert                    "MSSQL - dbconvert"
#define szST_dbdataready                  "MSSQL - dbdataready"
#define szST_dbdatlen                     "MSSQL - dbdatlen"
#define szST_dberrhandle                  "MSSQL - dberrhandle"
#define szST_dbfreebuf                    "MSSQL - dbfreebuf"
#define szST_dbfreelogin                  "MSSQL - dbfreelogin"
#define szST_dbhasretstat                 "MSSQL - dbhasretstat"
#define szST_dbinit                       "MSSQL - dbinit"
#define szST_dblogin                      "MSSQL - dblogin"
#define szST_dbmoretext                   "MSSQL - dbmoretext"
#define szST_dbmsghandle                  "MSSQL - dbmsghandle"
#define szST_dbnextrow                    "MSSQL - dbnextrow"
#define szST_dbnumcols                    "MSSQL - dbnumcols"
#define szST_dbnumrets                    "MSSQL - dbnumrets"
#define szST_dbopen                       "MSSQL - dbopen"
#define szST_dbresults                    "MSSQL - dbresults"
#define szST_dbretdata                    "MSSQL - dbretdata"
#define szST_dbretlen                     "MSSQL - dbretlen"
#define szST_dbretstatus                  "MSSQL - dbretstatus"
#define szST_dbrpcinit                    "MSSQL - dbrpcinit"
#define szST_dbrpcparam                   "MSSQL - dbrpcparam"
#define szST_dbrpcsend                    "MSSQL - dbrpcsend"
#define szST_dbsetlogintime               "MSSQL - dbsetlogintime"
#define szST_dbsetmaxprocs                "MSSQL - dbsetmaxprocs"
#define szST_dbsetopt                     "MSSQL - dbsetopt"
#define szST_dbsettime                    "MSSQL - dbsettime"
#define szST_dbsqlexec                    "MSSQL - dbsqlexec"
#define szST_dbsqlok                      "MSSQL - dbsqlok"
#define szST_dbsqlsend                    "MSSQL - dbsqlsend"
#define szST_dbtxptr                      "MSSQL - dbtxptr"
#define szST_dbtxtimestamp                "MSSQL - dbtxtimestamp"
#define szST_dbtxtsnewval                 "MSSQL - dbtxtsnewval"
#define szST_dbuse                        "MSSQL - dbuse"
#define szST_dbwinexit                    "MSSQL - dbwinexit"
#define szST_dbwritetext                  "MSSQL - dbwritetext"
#define szST_dbdead                       "MSSQL - dbdead"
#define szST_dbcount                      "MSSQL - dbcount"
#define szST_dbcolinfo                    "MSSQL - dbcolinfo"
#define szST_dbrpcexec                    "MSSQL - dbrpcexec"
#define szST_dbcanquery                   "MSSQL - dbcanquery"

// ODBC VENDOR CALLS
 
#define iST_SQLAllocConnect               (ST_BASE + 130)
#define iST_SQLAllocEnv                   (ST_BASE + 131)
#define iST_SQLAllocStmt                  (ST_BASE + 132)
#define iST_SQLBindCol                    (ST_BASE + 133)
#define iST_SQLBindParameter              (ST_BASE + 134)
#define iST_SQLCancel                     (ST_BASE + 135)
#define iST_SQLColumns                    (ST_BASE + 136)
#define iST_SQLConnect                    (ST_BASE + 137)
#define iST_SQLDataSources                (ST_BASE + 138)
#define iST_SQLDescribeCol                (ST_BASE + 139)
#define iST_SQLDisconnect                 (ST_BASE + 140)
#define iST_SQLDriverConnect              (ST_BASE + 141)
#define iST_SQLError                      (ST_BASE + 142)
#define iST_SQLExecDirect                 (ST_BASE + 143)
#define iST_SQLExtendedFetch              (ST_BASE + 144)
#define iST_SQLFetch                      (ST_BASE + 145)
#define iST_SQLFreeConnect                (ST_BASE + 146)
#define iST_SQLFreeEnv                    (ST_BASE + 147)
#define iST_SQLFreeStmt                   (ST_BASE + 148)
#define iST_SQLGetConnectOption           (ST_BASE + 149)
#define iST_SQLGetCursorName              (ST_BASE + 150)
#define iST_SQLGetData                    (ST_BASE + 151)
#define iST_SQLGetFunctions               (ST_BASE + 152)
#define iST_SQLGetInfo                    (ST_BASE + 153)
#define iST_SQLGetTypeInfo                (ST_BASE + 154)
#define iST_SQLNumResultCols              (ST_BASE + 155)
#define iST_SQLProcedures                 (ST_BASE + 156)
#define iST_SQLProcedureColumns           (ST_BASE + 157)
#define iST_SQLRowCount                   (ST_BASE + 158)
#define iST_SQLSetConnectOption           (ST_BASE + 159)
#define iST_SQLSetCursorName              (ST_BASE + 160)
#define iST_SQLSetParam                   (ST_BASE + 161)
#define iST_SQLSetStmtOption              (ST_BASE + 162)
#define iST_SQLStatistics                 (ST_BASE + 163)
#define iST_SQLTables                     (ST_BASE + 164)
#define iST_SQLTransact                   (ST_BASE + 165)

#define szST_SQLAllocConnect              "ODBC - SQLAllocConnect"
#define szST_SQLAllocEnv                  "ODBC - SQLAllocEnv"
#define szST_SQLAllocStmt                 "ODBC - SQLAllocStmt"
#define szST_SQLBindCol                   "ODBC - SQLBindCol"
#define szST_SQLBindParameter             "ODBC - SQLBindParameter"
#define szST_SQLCancel                    "ODBC - SQLCancel"
#define szST_SQLColumns                   "ODBC - SQLColumns"
#define szST_SQLConnect                   "ODBC - SQLConnect"
#define szST_SQLDataSources               "ODBC - SQLDataSources"
#define szST_SQLDescribeCol               "ODBC - SQLDescribeCol"
#define szST_SQLDisconnect                "ODBC - SQLDisconnect"
#define szST_SQLDriverConnect             "ODBC - SQLDriverConnect"
#define szST_SQLError                     "ODBC - SQLError"
#define szST_SQLExecDirect                "ODBC - SQLExecDirect"
#define szST_SQLExtendedFetch             "ODBC - SQLExtendedFetch"
#define szST_SQLFetch                     "ODBC - SQLFetch"
#define szST_SQLFreeConnect               "ODBC - SQLFreeConnect"
#define szST_SQLFreeEnv                   "ODBC - SQLFreeEnv"
#define szST_SQLFreeStmt                  "ODBC - SQLFreeStmt"
#define szST_SQLGetConnectOption          "ODBC - SQLGetConnectOption"
#define szST_SQLGetCursorName             "ODBC - SQLGetCursorName"
#define szST_SQLGetData                   "ODBC - SQLGetData"
#define szST_SQLGetFunctions              "ODBC - SQLGetFunctions"
#define szST_SQLGetInfo                   "ODBC - SQLGetInfo"
#define szST_SQLGetTypeInfo               "ODBC - SQLGetTypeInfo"
#define szST_SQLNumResultCols             "ODBC - SQLNumResultCols"
#define szST_SQLProcedures                "ODBC - SQLProcedures"
#define szST_SQLProcedureColumns          "ODBC - SQLProcedureColumns"
#define szST_SQLRowCount                  "ODBC - SQLRowCount"
#define szST_SQLSetConnectOption          "ODBC - SQLSetConnectOption"
#define szST_SQLSetCursorName             "ODBC - SQLSetCursorName"
#define szST_SQLSetParam                  "ODBC - SQLSetParam"
#define szST_SQLSetStmtOption             "ODBC - SQLSetStmtOption"
#define szST_SQLStatistics                "ODBC - SQLStatistics"
#define szST_SQLTables                    "ODBC - SQLTables"
#define szST_SQLTransact                  "ODBC - SQLTransact"

// SYBASE VENDOR CALLS
 
#define iST_SYBdbbind                     (ST_BASE + 180)
#define iST_SYBdbcmd                      (ST_BASE + 181)
#define iST_SYBdbcancel                   (ST_BASE + 182)
#define iST_SYBdbclose                    (ST_BASE + 183)
#define iST_SYBdbcollen                   (ST_BASE + 184)
#define iST_SYBdbcolname                  (ST_BASE + 185)
#define iST_SYBdbcoltype                  (ST_BASE + 186)
#define iST_SYBdbconvert                  (ST_BASE + 187)
#define iST_SYBdbpoll                     (ST_BASE + 188)
#define iST_SYBdbdatlen                   (ST_BASE + 189)
#define iST_SYBdberrhandle                (ST_BASE + 190)
#define iST_SYBdbfreebuf                  (ST_BASE + 191)
#define iST_SYBdbloginfree                (ST_BASE + 192)
#define iST_SYBdbhasretstat               (ST_BASE + 193)
#define iST_SYBdbinit                     (ST_BASE + 194)
#define iST_SYBdblogin                    (ST_BASE + 195)
#define iST_SYBdbmoretext                 (ST_BASE + 196)
#define iST_SYBdbmsghandle                (ST_BASE + 197)
#define iST_SYBdbnextrow                  (ST_BASE + 198)
#define iST_SYBdbnumcols                  (ST_BASE + 199)
#define iST_SYBdbnumrets                  (ST_BASE + 200)
#define iST_SYBdbopen                     (ST_BASE + 201)
#define iST_SYBdbresults                  (ST_BASE + 202)
#define iST_SYBdbretdata                  (ST_BASE + 203)
#define iST_SYBdbretlen                   (ST_BASE + 204)
#define iST_SYBdbretstatus                (ST_BASE + 205)
#define iST_SYBdbrpcinit                  (ST_BASE + 206)
#define iST_SYBdbrpcparam                 (ST_BASE + 207)
#define iST_SYBdbrpcsend                  (ST_BASE + 208)
#define iST_SYBdbsetlogintime             (ST_BASE + 209)
#define iST_SYBdbsetmaxprocs              (ST_BASE + 210)
#define iST_SYBdbsetopt                   (ST_BASE + 211)
#define iST_SYBdbsettime                  (ST_BASE + 212)
#define iST_SYBdbsqlexec                  (ST_BASE + 213)
#define iST_SYBdbsqlok                    (ST_BASE + 214)
#define iST_SYBdbsqlsend                  (ST_BASE + 215)
#define iST_SYBdbtxptr                    (ST_BASE + 216)
#define iST_SYBdbtxtimestamp              (ST_BASE + 217)
#define iST_SYBdbtxtsnewval               (ST_BASE + 218)
#define iST_SYBdbuse                      (ST_BASE + 219)
#define iST_SYBdbwinexit                  (ST_BASE + 220)
#define iST_SYBdbwritetext                (ST_BASE + 221)
#define iST_SYBdbcount                    (ST_BASE + 222)
#define iST_SYBdbdead                     (ST_BASE + 223)
 
#define szST_SYBdbbind                    "SYBASE - dbbind"
#define szST_SYBdbcmd                     "SYBASE - dbcmd"
#define szST_SYBdbcancel                  "SYBASE - dbcancel"
#define szST_SYBdbclose                   "SYBASE - dbclose"
#define szST_SYBdbcollen                  "SYBASE - dbcollen"
#define szST_SYBdbcolname                 "SYBASE - dbcolname"
#define szST_SYBdbcoltype                 "SYBASE - dbcoltype"
#define szST_SYBdbconvert                 "SYBASE - dbconvert"
#define szST_SYBdbpoll                    "SYBASE - dbpoll"
#define szST_SYBdbdatlen                  "SYBASE - dbdatlen"
#define szST_SYBdberrhandle               "SYBASE - dberrhandle"
#define szST_SYBdbfreebuf                 "SYBASE - dbfreebuf"
#define szST_SYBdbloginfree               "SYBASE - dbloginfree"
#define szST_SYBdbhasretstat              "SYBASE - dbhasretstat"
#define szST_SYBdbinit                    "SYBASE - dbinit"
#define szST_SYBdblogin                   "SYBASE - dblogin"
#define szST_SYBdbmoretext                "SYBASE - dbmoretext"
#define szST_SYBdbmsghandle               "SYBASE - dbmsghandle"
#define szST_SYBdbnextrow                 "SYBASE - dbnextrow"
#define szST_SYBdbnumcols                 "SYBASE - dbnumcols"
#define szST_SYBdbnumrets                 "SYBASE - dbnumrets"
#define szST_SYBdbopen                    "SYBASE - dbopen"
#define szST_SYBdbresults                 "SYBASE - dbresults"
#define szST_SYBdbretdata                 "SYBASE - dbretdata"
#define szST_SYBdbretlen                  "SYBASE - dbretlen"
#define szST_SYBdbretstatus               "SYBASE - dbretstatus"
#define szST_SYBdbrpcinit                 "SYBASE - dbrpcinit"
#define szST_SYBdbrpcparam                "SYBASE - dbrpcparam"
#define szST_SYBdbrpcsend                 "SYBASE - dbrpcsend"
#define szST_SYBdbsetlogintime            "SYBASE - dbsetlogintime"
#define szST_SYBdbsetmaxprocs             "SYBASE - dbsetmaxprocs"
#define szST_SYBdbsetopt                  "SYBASE - dbsetopt"
#define szST_SYBdbsettime                 "SYBASE - dbsettime"
#define szST_SYBdbsqlexec                 "SYBASE - dbsqlexec"
#define szST_SYBdbsqlok                   "SYBASE - dbsqlok"
#define szST_SYBdbsqlsend                 "SYBASE - dbsqlsend"
#define szST_SYBdbtxptr                   "SYBASE - dbtxptr"
#define szST_SYBdbtxtimestamp             "SYBASE - dbtxtimestamp"
#define szST_SYBdbtxtsnewval              "SYBASE - dbtxtsnewval"
#define szST_SYBdbuse                     "SYBASE - dbuse"
#define szST_SYBdbwinexit                 "SYBASE - dbwinexit"
#define szST_SYBdbwritetext               "SYBASE - dbwritetext"
#define szST_SYBdbcount                   "SYBASE - dbcount"
#define szST_SYBdbdead                    "SYBASE - dbdead"

// SYBASE CT-LIB vendor calls.

#define iST_SYBct_callback                (ST_BASE + 400)
#define iST_SYBcs_ctx_alloc               (ST_BASE + 401)
#define iST_SYBcs_ctx_drop                (ST_BASE + 402)
#define iST_SYBcs_convert                 (ST_BASE + 403)
#define iST_SYBct_init                    (ST_BASE + 404)
#define iST_SYBct_config                  (ST_BASE + 405)
#define iST_SYBct_con_alloc               (ST_BASE + 406)
#define iST_SYBct_con_props               (ST_BASE + 407)
#define iST_SYBct_connect                 (ST_BASE + 408)
#define iST_SYBct_close                   (ST_BASE + 409)
#define iST_SYBct_con_drop                (ST_BASE + 410)
#define iST_SYBct_options                 (ST_BASE + 411)
#define iST_SYBct_cmd_alloc               (ST_BASE + 412)
#define iST_SYBct_command                 (ST_BASE + 413)
#define iST_SYBct_cursor                  (ST_BASE + 414)
#define iST_SYBct_param                   (ST_BASE + 415)
#define iST_SYBct_bind                    (ST_BASE + 416)
#define iST_SYBct_send                    (ST_BASE + 417)
#define iST_SYBct_results                 (ST_BASE + 418)
#define iST_SYBct_res_info                (ST_BASE + 419)
#define iST_SYBct_describe                (ST_BASE + 420)
#define iST_SYBct_fetch                   (ST_BASE + 421)
#define iST_SYBct_get_data                (ST_BASE + 422)
#define iST_SYBct_data_info               (ST_BASE + 423)
#define iST_SYBct_send_data               (ST_BASE + 424)
#define iST_SYBct_cancel                  (ST_BASE + 425)
#define iST_SYBct_cmd_drop                (ST_BASE + 426)
#define iST_SYBct_exit                    (ST_BASE + 427)

#define szST_SYBct_callback               "SYBASE - ct_callback"
#define szST_SYBcs_ctx_alloc              "SYBASE - cs_ctx_alloc"
#define szST_SYBcs_ctx_drop               "SYBASE - cs_ctx_drop"
#define szST_SYBcs_convert                "SYBASE - cs_convert"
#define szST_SYBct_options                "SYBASE - ct_options"
#define szST_SYBct_init                   "SYBASE - ct_init"
#define szST_SYBct_config                 "SYBASE - ct_config"
#define szST_SYBct_con_alloc              "SYBASE - ct_con_alloc"
#define szST_SYBct_con_props              "SYBASE - ct_con_props"
#define szST_SYBct_connect                "SYBASE - ct_connect"
#define szST_SYBct_close                  "SYBASE - ct_close"
#define szST_SYBct_con_drop               "SYBASE - ct_con_drop"
#define szST_SYBct_options                "SYBASE - ct_options"
#define szST_SYBct_cmd_alloc              "SYBASE - ct_cmd_alloc"
#define szST_SYBct_command                "SYBASE - ct_command"
#define szST_SYBct_cursor                 "SYBASE - ct_cursor"
#define szST_SYBct_param                  "SYBASE - ct_param"
#define szST_SYBct_bind                   "SYBASE - ct_bind"
#define szST_SYBct_send                   "SYBASE - ct_send"
#define szST_SYBct_results                "SYBASE - ct_results"
#define szST_SYBct_res_info               "SYBASE - ct_res_info"
#define szST_SYBct_describe               "SYBASE - ct_describe"
#define szST_SYBct_fetch                  "SYBASE - ct_fetch"
#define szST_SYBct_get_data               "SYBASE - ct_get_data"
#define szST_SYBct_data_info              "SYBASE - ct_data_info"
#define szST_SYBct_send_data              "SYBASE - ct_send_data"
#define szST_SYBct_cancel                 "SYBASE - ct_cancel"
#define szST_SYBct_cmd_drop               "SYBASE - ct_cmd_drop"
#define szST_SYBct_exit                   "SYBASE - ct_exit"

// SQL Generic Strings
 
#define iST_Close                         (ST_BASE + 300)
#define iST_ReturnBlobData                (ST_BASE + 301)
#define iST_SetStmtType                   (ST_BASE + 302)
#define iST_SetCurName                    (ST_BASE + 303)
#define iST_SetRowsetSize                 (ST_BASE + 304)
#define iST_SetStoredProc                 (ST_BASE + 305)
#define iST_Fetch                         (ST_BASE + 306)
#define iST_EOF                           (ST_BASE + 307)
#define iST_RowFetchLimit                 (ST_BASE + 308)
#define iST_Error                         (ST_BASE + 309)
#define iST_Reset                         (ST_BASE + 310)
#define iST_BlobReadSize                  (ST_BASE + 311)
#define iST_Allocate                      (ST_BASE + 312)
#define iST_DisconnectN                   (ST_BASE + 313)
#define iST_DisconnectG                   (ST_BASE + 314)
#define iST_DisconnectP                   (ST_BASE + 315)
#define iST_XactBegin                     (ST_BASE + 316)
#define iST_XactSave                      (ST_BASE + 317)
#define iST_XactCommit                    (ST_BASE + 318)
#define iST_XactCommitAll                 (ST_BASE + 319)
#define iST_XactCommitKeep                (ST_BASE + 320)
#define iST_XactAbort                     (ST_BASE + 321)
#define iST_XactRollback                  (ST_BASE + 322)
#define iST_XactSetReadOnly               (ST_BASE + 323)
#define iST_XactUnknown                   (ST_BASE + 324)
#define iST_XReadCommitted                (ST_BASE + 325)
#define iST_XRepeatableRead               (ST_BASE + 326)
#define iST_AutoCommit                    (ST_BASE + 327)
#define iST_BlobStartStore                (ST_BASE + 328)
#define iST_BlobStore                     (ST_BASE + 329)
#define iST_BlobGet                       (ST_BASE + 330)
#define iST_BlobGetLen                    (ST_BASE + 331)
#define iST_BlobGetSchema                 (ST_BASE + 332)
#define iST_BlobGetLenSchema              (ST_BASE + 333)
#define iST_UnmappedError                      (ST_BASE + 334)


#define szST_Close                        "Close"
#define szST_ReturnBlobData               "Return blob data"
#define szST_SetStmtType                  "Set statement type"
#define szST_SetCurName                   "Set cursor name"
#define szST_SetRowsetSize                "Set rowset size"
#define szST_SetStoredProc                "Set stored procedure on or off"
#define szST_Fetch                        "Fetch"
#define szST_EOF                          "EOF"
#define szST_RowFetchLimit                "ROW FETCH LIMIT"
#define szST_Error                        "ERROR"
#define szST_Reset                        "Reset"
#define szST_BlobReadSize                 "Get Blob - READ4SIZE"
#define szST_Allocate                     "Allocate"
#define szST_DisconnectN                  "Disconnect NEW"
#define szST_DisconnectG                  "Disconnect GENERAL"
#define szST_DisconnectP                  "Disconnect PASSTHRU"
#define szST_XactBegin                    "XACT Begin"
#define szST_XactSave                     "XACT SavePoint"
#define szST_XactCommit                   "XACT Commit"
#define szST_XactCommitAll                "XACT Commit All"
#define szST_XactCommitKeep               "XACT Commit Keep"
#define szST_XactAbort                    "XACT Abort"
#define szST_XactRollback                 "XACT Rollback to savepoint"
#define szST_XactSetReadOnly              "XACT Set Read Only"
#define szST_XactUnknown                  "XACT (UNKNOWN)"
#define szST_XactReadCommitted            "XACT ReadCommitted"
#define szST_XactRepeatableRead           "XACT RepeatableRead"
#define szST_AutoCommit                   "Set autocommit on/off"
#define szST_BlobStartStore               "Start Store"
#define szST_BlobStore                    "Store"
#define szST_BlobGet                      "Get"
#define szST_BlobGetLen                   "Get Len"
#define szST_BlobGetSchema                "Get (SCHEMA)"
#define szST_BlobGetLenSchema             "Get Len (SCHEMA)"
#define szST_UnmappedError                "Unmapped SQL Error Code"

//DB2 VENDOR CALLS
 
#define ST_SQLAllocConnect               (ST_BASE + 350)
#define ST_SQLAllocEnv                   (ST_BASE + 351)
#define ST_SQLAllocStmt                  (ST_BASE + 352)
#define ST_SQLBindCol                    (ST_BASE + 353)
#define ST_SQLBindParameter              (ST_BASE + 354)
#define ST_SQLCancel                     (ST_BASE + 355)
#define ST_SQLColumns                    (ST_BASE + 356)
#define ST_SQLConnect                    (ST_BASE + 357)
#define ST_SQLDataSources                (ST_BASE + 358)
#define ST_SQLDescribeCol                (ST_BASE + 359)
#define ST_SQLDisconnect                 (ST_BASE + 360)
#define ST_SQLDriverConnect              (ST_BASE + 361)
#define ST_SQLError                      (ST_BASE + 362)
#define ST_SQLExecDirect                 (ST_BASE + 363)
#define ST_SQLExtendedFetch              (ST_BASE + 364)
#define ST_SQLFetch                      (ST_BASE + 365)
#define ST_SQLFreeConnect                (ST_BASE + 366)
#define ST_SQLFreeEnv                    (ST_BASE + 367)
#define ST_SQLFreeStmt                   (ST_BASE + 368)
#define ST_SQLGetConnectOption           (ST_BASE + 369)
#define ST_SQLGetCursorName              (ST_BASE + 370)
#define ST_SQLGetData                    (ST_BASE + 371)
#define ST_SQLGetFunctions               (ST_BASE + 372)
#define ST_SQLGetInfo                    (ST_BASE + 373)
#define ST_SQLGetTypeInfo                (ST_BASE + 374)
#define ST_SQLNumResultCols              (ST_BASE + 375)
#define ST_SQLProcedures                 (ST_BASE + 376)
#define ST_SQLProcedureColumns           (ST_BASE + 377)
#define ST_SQLRowCount                   (ST_BASE + 388)
#define ST_SQLSetConnectOption           (ST_BASE + 399)
#define ST_SQLSetCursorName              (ST_BASE + 400)
#define ST_SQLSetParam                   (ST_BASE + 411)
#define ST_SQLSetStmtOption              (ST_BASE + 412)
#define ST_SQLStatistics                 (ST_BASE + 413)
#define ST_SQLTables                     (ST_BASE + 414)
#define ST_SQLTransact                   (ST_BASE + 415)
#define ST_SQLPutData                    (ST_BASE + 416) 
#define ST_SQLParamData                  (ST_BASE + 417) 
#define ST_SQLGetLength                  (ST_BASE + 418)
#define ST_SQLGetSubString               (ST_BASE + 419)
#define ST_SQLPrepare                    (ST_BASE + 420)
#define ST_SQLExecute                    (ST_BASE + 421)

#define szSQLAllocConnect              "DB2 - SQLAllocConnect"
#define szSQLAllocEnv                  "DB2 - SQLAllocEnv"
#define szSQLAllocStmt                 "DB2 - SQLAllocStmt"
#define szSQLBindCol                   "DB2 - SQLBindCol"
#define szSQLBindParameter             "DB2 - SQLBindParameter"
#define szSQLCancel                    "DB2 - SQLCancel"
#define szSQLColumns                   "DB2 - SQLColumns"
#define szSQLConnect                   "DB2 - SQLConnect"
#define szSQLDataSources               "DB2 - SQLDataSources"
#define szSQLDescribeCol               "DB2 - SQLDescribeCol"
#define szSQLDisconnect                "DB2 - SQLDisconnect"
#define szSQLDriverConnect             "DB2 - SQLDriverConnect"
#define szSQLError                     "DB2 - SQLError"
#define szSQLExecDirect                "DB2 - SQLExecDirect"
#define szSQLExtendedFetch             "DB2 - SQLExtendedFetch"
#define szSQLFetch                     "DB2 - SQLFetch"
#define szSQLFreeConnect               "DB2 - SQLFreeConnect"
#define szSQLFreeEnv                   "DB2 - SQLFreeEnv"
#define szSQLFreeStmt                  "DB2 - SQLFreeStmt"
#define szSQLGetConnectOption          "DB2 - SQLGetConnectOption"
#define szSQLGetCursorName             "DB2 - SQLGetCursorName"
#define szSQLGetData                   "DB2 - SQLGetData"
#define szSQLGetFunctions              "DB2 - SQLGetFunctions"
#define szSQLGetInfo                   "DB2 - SQLGetInfo"
#define szSQLGetTypeInfo               "DB2 - SQLGetTypeInfo"
#define szSQLNumResultCols             "DB2 - SQLNumResultCols"
#define szSQLProcedures                "DB2 - SQLProcedures"
#define szSQLProcedureColumns          "DB2 - SQLProcedureColumns"
#define szSQLRowCount                  "DB2 - SQLRowCount"
#define szSQLSetConnectOption          "DB2 - SQLSetConnectOption"
#define szSQLSetCursorName             "DB2 - SQLSetCursorName"
#define szSQLSetParam                  "DB2 - SQLSetParam"
#define szSQLSetStmtOption             "DB2 - SQLSetStmtOption"
#define szSQLStatistics                "DB2 - SQLStatistics"
#define szSQLTables                    "DB2 - SQLTables"
#define szSQLTransact                  "DB2 - SQLTransact"
#define szSQLPutData                   "DB2 - SQLPutData"
#define szSQLParamData                 "DB2 - SQLParamData"
#define szSQLGetLength                 "DB2 - SQLGetLength"
#define szSQLGetSubString              "DB2 - SQLGetSubString"
#define szSQLPrepare                   "DB2 - SQLPrepare"
#define szSQLExecute                   "DB2 - SQLExecute"

//INFORMIX Vendor trace 
#define ST_szSetConnect                 (ST_BASE + 450)
#define ST_szGetConnect                 (ST_BASE + 451)
#define ST_szReleaseConnect             (ST_BASE + 452)
#define ST_szOpenDatabase               (ST_BASE + 453)
#define ST_szCloseDatabase              (ST_BASE + 454)
#define ST_szBeginWork                  (ST_BASE + 455)
#define ST_szCommitWork                 (ST_BASE + 456)
#define ST_szRollbackWork               (ST_BASE + 457) 
#define ST_szSetIsolationLevel          (ST_BASE + 458)
#define ST_szSetInetLoginStruct         (ST_BASE + 459)
#define ST_szExecute                    (ST_BASE + 460)
#define ST_szDeclareCursor              (ST_BASE + 461) 
#define ST_szOpenCursor                 (ST_BASE + 462)
#define ST_szCloseCursor                (ST_BASE + 463) 
#define ST_szFreeCursor                 (ST_BASE + 464)
#define ST_szFreeStatement              (ST_BASE + 465)
#define ST_szPrepareStatement           (ST_BASE + 466)
#define ST_szDescribe                   (ST_BASE + 467)
#define ST_szFetch                      (ST_BASE + 468) 
#define ST_szGetErrorMessage            (ST_BASE + 469)
#define ST_szSqlDone                    (ST_BASE + 470) 
#define ST_szSqlBreak                   (ST_BASE + 471) 

#define szSetConnect            "ESQL/C SetConnect"
#define szGetConnect            "ESQL/C GetConnect"
#define szReleaseConnect        "ESQL/C ReleaseConnect"
#define szOpenDatabase          "ESQL/C Open Database"
#define szCloseDatabase         "ESQL/C Close Database"
#define szBeginWork             "ESQL/C Begin Work"
#define szCommitWork            "ESQL/C Commit Work"
#define szRollbackWork          "ESQL/C Rollback Work"
#define szSetIsolationLevel     "ESQL/C SetIsolationLevel"
#define szSetInetLoginStruct    "ESQL/C SetInetLogin"
#define szExecute               "ESQL/C Execute"
#define szDeclareCursor         "ESQL/C Declare Cursor"
#define szOpenCursor            "ESQL/C Open Cursor"
#define szCloseCursor           "ESQL/C Close Cursor"
#define szFreeCursor            "ESQL/C Free Cursor"
#define szFreeStatement         "ESQL/C Free Statement"
#define szPrepareStatement      "ESQL/C Prepare Statement"
#define szDescribe              "ESQL/C Describe Statement"
#define szFetch                 "ESQL/C Fetch"
#define szGetErrorMessage       "ESQL/C GetErrorMessage"
#define szSqlDone               "ESQL/C sqldone"
#define szSqlBreak              "ESQL/C sqlbreak"

// Resource string for SQLTRACE DATA

#define ST_szFLDParam			(ST_BASE + 500)	
#define ST_szFLDColumn			(ST_BASE + 501)	
#define ST_szFLDName			(ST_BASE + 502)	
#define ST_szFLDType			(ST_BASE + 503)	
#define ST_szFLDPrecision		(ST_BASE + 504)	
#define ST_szFLDScale			(ST_BASE + 505)	
#define ST_szFLData			(ST_BASE + 506)	
#define ST_szRowsAffected		(ST_BASE + 507)	

#define szFLDParam		"Param"
#define szFLDColumn		"Column"
#define szFLDName		"Name"
#define szFLDType		"Type"		
#define szFLDPrecision	  	"Precision"	
#define szFLDScale		"Scale"	
#define szFLDData		"Data"
#define szRowsAffected		"Rows affected"


#define iST_DATAIN	         ( ST_BASE + 508 )
#define iST_DATAOUT 		 ( ST_BASE + 509 )

#define szST_DATAIN	          "SQL Data In"
#define szST_DATAOUT	          "SQL Data Out"

//ORACLE 8 VENDOR CALLS

#define ST_szOCI_Execute        ( ST_BASE + 510 )
#define ST_szOCI_FreeStmtHandle ( ST_BASE + 511 )
#define ST_szOCI_GetRowCount    ( ST_BASE + 512 )
#define ST_szOCI_GetRowID       ( ST_BASE + 513 )
#define ST_szOCI_AllocDesc      ( ST_BASE + 514 )
#define ST_szOCI_DescFree       ( ST_BASE + 515 )
#define ST_szOCI_AllocBindHndl  ( ST_BASE + 516 )
#define ST_szOCI_BindByName     ( ST_BASE + 517 ) 
#define ST_szOCI_BindByPos      ( ST_BASE + 518 )
#define ST_szOCI_RsetToStmt     ( ST_BASE + 519 )
#define ST_szOCI_StmtGetPiece   ( ST_BASE + 520 ) 
#define ST_szOCI_StmtSetPiece   ( ST_BASE + 521 )
#define ST_szOCI_StmtFetch      ( ST_BASE + 522 )
#define ST_szOCI_StmtPrepare    ( ST_BASE + 523 )
#define ST_szOCI_ServerAttach   ( ST_BASE + 524 ) 
#define ST_szOCI_SetUser        ( ST_BASE + 525 )
#define ST_szOCI_SetPass        ( ST_BASE + 526 )
#define ST_szOCI_AttrSet        ( ST_BASE + 527 )
#define ST_szOCI_SessionBegin   ( ST_BASE + 528 )
#define ST_szOCI_SessionEnd     ( ST_BASE + 529 ) 
#define ST_szOCI_SvcToLda       ( ST_BASE + 530 ) 
#define ST_szOCI_Ocon           ( ST_BASE + 531 ) 
#define ST_szOCI_Ocof           ( ST_BASE + 532 )
#define ST_szOCI_ServerDetach   ( ST_BASE + 533 )
#define ST_szOCI_FreeServerHndl ( ST_BASE + 534 )
#define ST_szOCI_FreeServHndl   ( ST_BASE + 535 )
#define ST_szOCI_FreeErrorHndl  ( ST_BASE + 536 )
#define ST_szOCI_FreeEnvHndl    ( ST_BASE + 537 )
#define ST_szOCI_FreeSessHndl   ( ST_BASE + 538 )
#define ST_szOCI_FreeTransHndl  ( ST_BASE + 539 )
#define ST_szOCI_GetError       ( ST_BASE + 540 )
#define ST_szOCI_Initialize     ( ST_BASE + 541 )
#define ST_szOCI_Env            ( ST_BASE + 542 )
#define ST_szOCI_AllocHndl      ( ST_BASE + 543 )
#define ST_szOCI_AllocDefHndl   ( ST_BASE + 544 )
#define ST_szOCI_Define         ( ST_BASE + 545 )
#define ST_szOCI_Fetch          ( ST_BASE + 546 )
#define ST_szOCI_GetParam       ( ST_BASE + 547 )
#define ST_szOCI_AttrGet        ( ST_BASE + 548 )
#define ST_szOCI_FreeBndHndl    ( ST_BASE + 549 )
#define ST_szOCI_FreeDefnHndl   ( ST_BASE + 550 )
#define ST_szOCI_FreeDescHndl   ( ST_BASE + 551 )
#define ST_szOCI_FreeStmtHndl   ( ST_BASE + 552 ) 
#define ST_szOCI_Describe       ( ST_BASE + 553 )
#define ST_szOCI_ObjectPin      ( ST_BASE + 554 )
#define ST_szOCI_ObjectUnpin    ( ST_BASE + 555 )
#define ST_szOCI_ObjectFree     ( ST_BASE + 556 )

#define szOCI_Execute        "OCI 8 - OCIStmtExecute"
#define szOCI_FreeStmtHandle "OCI 8 - OCIHandleFree(OCI_HTYPE_STMT)"
#define szOCI_GetRowCount    "OCI 8 - OCIAttrGet(OCI_ATTR_ROWCNT)"
#define szOCI_GetRowID       "OCI 8 - OCIAttrGet(OCI_ATTR_ROWID)"
#define szOCI_AllocDesc      "OCI 8 - OCIDescriptorAlloc"
#define szOCI_DescFree       "OCI 8 - OCIDescriptorFree"
#define szOCI_AllocBindHndl  "OCI 8 - OCIHandleAlloc(OCI_HTYPE_BIND)"
#define szOCI_BindByName     "OCI 8 - OCIBindByName"
#define szOCI_BindByPos      "OCI 8 - OCIBindByPos"
#define szOCI_RsetToStmt     "OCI 8 - OCIResultSetToStmt"
#define szOCI_StmtGetPiece   "OCI 8 - OCIStmtGetPieceInfo"
#define szOCI_StmtSetPiece   "OCI 8 - OCIStmtSetPieceInfo"
#define szOCI_StmtFetch      "OCI 8 - OCIStmtFetch"
#define szOCI_StmtPrepare    "OCI 8 - OCIStmtPrepare"
#define szOCI_ServerAttach   "OCI 8 - OCIServerAttach"
#define szOCI_SetUser        "OCI 8 - OCIAttrSet(OCI_ATTR_USERNAME)"
#define szOCI_SetPass        "OCI 8 - OCIAttrSet(OCI_ATTR_PASSWORD)"
#define szOCI_AttrSet        "OCI 8 - OCIAttrSet"
#define szOCI_SessionBegin   "OCI 8 - OCISessionBegin"
#define szOCI_SessionEnd     "OCI 8 - OCISessionEnd"
#define szOCI_SvcToLda       "OCI 8 - OCISvcCtxToLda"
#define szOCI_Ocon           "OCI 8 - Ocon"
#define szOCI_Ocof           "OCI 8 - Ocof"
#define szOCI_ServerDetach   "OCI 8 - OCIServerDetach"
#define szOCI_FreeServerHndl "OCI 8 - OCIHandleFree(OCI_HTYPE_SERVER)"
#define szOCI_FreeServHndl   "OCI 8 - OCIHandleFree(OCI_HTYPE_SERVICE)"
#define szOCI_FreeErrorHndl  "OCI 8 - OCIHandleFree(OCI_HTYPE_ERROR)"
#define szOCI_FreeEnvHndl    "OCI 8 - OCIHandleFree(OCI_HTYPE_ENV)"
#define szOCI_FreeSessHndl   "OCI 8 - OCIHandleFree(OCI_HTYPE_SESSION)"
#define szOCI_FreeTransHndl  "OCI 8 - OCIHandleFree(OCI_HTYPE_TRANS)"
#define szOCI_GetError       "OCI 8 - OCIErrorGet"
#define szOCI_Initialize     "OCI 8 - OCIInitialize"
#define szOCI_Env            "OCI 8 - OCIEnvInit"
#define szOCI_AllocHndl      "OCI 8 - OCIHandleAlloc"
#define szOCI_AllocDefHndl   "OCI 8 - OCIHandleAlloc(OCI_HTYPE_DEFINE)"
#define szOCI_Define         "OCI 8 - OCIDefn"
#define szOCI_Fetch          "OCI 8 - OCIStmtFetch"
#define szOCI_GetParam       "OCI 8 - OCIParamGet"
#define szOCI_AttrGet        "OCI 8 - OCIAttrGet"
#define szOCI_FreeBndHndl    "OCI 8 - OCIHandleFree(OCI_HTYPE_BIND)"
#define szOCI_FreeDefnHndl   "OCI 8 - OCIHandleFree(OCI_HTYPE_DEFINE)"
#define szOCI_FreeDescHndl   "OCI 8 - OCIHandleFree(OCI_HTYPE_DESC)"
#define szOCI_FreeStmtHndl   "OCI 8 - OCIHandleFree(OCI_HTYPE_STMT)"
#define szOCI_Describe       "OCI 8 - OCIDescribeAny"
#define szOCI_ObjectPin      "OCI 8 - OCIObjectPin"
#define szOCI_ObjectUnpin    "OCI 8 - OCIObjectUnpin"
#define szOCI_ObjectFree     "OCI 8 - OCIObjectFree"

#endif

