
/****************************************************************************

dbExpress - Cross-Platform, database independent data access interface

Copyright (c) 2000, 2001 Borland Software Corporation

This file may be distributed and/or modified under the terms of the GNU
General Public License (GPL) version 2 as published by the Free Software

Software Foundation and appearing at
http://www.borland.com/kylix/gpl.html.

Licensees holding a valid Borland No-Nonsense License for this Software
may use this file in accordance with such license, which appears in the file
license.txt that came with this Software.

****************************************************************************/

#ifndef SCH_CONST_H
#define SCH_CONST_H

// do not localize
#define NULLSTRING         "<NULL>"
#define ASCENDING          "A"
#define DESCENDING         "D"
#define UNKNOWN_COL_LENGTH  -1
// getObjectList()
const UINT16 ObjTblColCount = 4;
const UINT16 MaxColsPerIndex = 16;
const UINT32 ObjTblColNameLen[] = { 5, 6, 8, 11 };
const pCHAR ObjTblColName[] = { "RECNO", "SCHEMA", "CATEGORY", "OBJECT_NAME" };
const UINT16 ObjTblColType[] = { fldINT32, fldZSTRING, fldZSTRING, fldZSTRING };
const UINT16 ObjTblColSubType[] = { 0, 0, 0, 0 };
const INT32 ObjTblColLen[] = { 4, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH };
const INT16 ObjTblColPrec[] = { 0, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH };
const UINT16 ObjTblColScale[] = { 0, 0, 0, 0 };
const UINT16 ObjectIndexCol = 1;
const UINT16 ObjectSchemaCol = 2;
const UINT16 ObjectCatCol = 3;
const UINT16 ObjectObjectCol = 4;
// getTables()
const UINT16 TblObjColCount = 5;
const UINT32 TblObjColNameLen[] = { 5, 12, 11, 10, 10 };
const pCHAR TblObjColName[] = { "RECNO", "CATALOG_NAME", "SCHEMA_NAME", "TABLE_NAME", "TABLE_TYPE" };
const UINT16 TblObjColType[] = { fldINT32, fldZSTRING, fldZSTRING, fldZSTRING, fldINT32 };
const UINT16 TblObjColSubType[] = { 0, 0, 0, 0, 0 };
const INT32 TblObjColLen[] = { 4, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 4 };
const INT16 TblObjColPrec[] = { 0, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 0 };
const INT16 TblObjColScale[] = { 0, 0, 0, 0, 0 };
const UINT16 TblObjNameCol = 4;
const UINT16 TblObjTypeCol = 5;
// getProcedures()
const UINT16 ProcObjColCount = 7;
const UINT32 ProcObjColNameLen[] = {5, 12, 11, 9, 9, 9, 10 };
const pCHAR ProcObjColName[] = { "RECNO", "CATALOG_NAME", "SCHEMA_NAME", "PROC_NAME", "PROC_TYPE", "IN_PARAMS", "OUT_PARAMS" };
const UINT16 ProcObjColType[] = { fldINT32, fldZSTRING, fldZSTRING, fldZSTRING, fldINT32, fldINT32, fldINT32 };
const UINT16 ProcObjColSubType[] = { 0, 0, 0, 0, 0, 0, 0 };
const INT32 ProcObjColLen[] = { 4, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 4, 4, 4 };
const INT16 ProcObjColPrec[] = { 0, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 0, 0, 0 };
const INT16 ProcObjColScale[] = { 0, 0, 0, 0, 0, 0, 0 };
const UINT16 ProcObjNameCol = 4;
const UINT16 ProcObjTypeCol = 5;
const UINT16 ProcObjInArgCol = 6;
const UINT16 ProcObjOutArgCol = 7;
// getColumns( )
const UINT16 ColObjColCount = 14;
const UINT32 ColObjColNameLen[] = { 5, 12, 11, 10, 11, 15, 11, 15, 15, 14, 13, 16, 12, 15 };
const pCHAR ColObjColName[] = { "RECNO", "CATALOG_NAME", "SCHEMA_NAME", "TABLE_NAME", "COLUMN_NAME", "COLUMN_POSITION", "COLUMN_TYPE", "COLUMN_DATATYPE", "COLUMN_TYPENAME", "COLUMN_SUBTYPE", "COLUMN_LENGTH", "COLUMN_PRECISION", "COLUMN_SCALE", "COLUMN_NULLABLE" };
const UINT16 ColObjColType[] = { fldINT32, fldZSTRING, fldZSTRING, fldZSTRING, fldZSTRING, fldINT16, fldINT16, fldINT16, fldZSTRING, fldINT16, fldINT32, fldINT16, fldINT16, fldINT16 };
const UINT16 ColObjColSubType[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
const INT32 ColObjColLen[] = { 4, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 2, 2, 2, UNKNOWN_COL_LENGTH, 2, 4, 2, 2, 2 };
const INT16 ColObjColPrec[] = { 0, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 0, 0, 0, UNKNOWN_COL_LENGTH, 0, 0, 0, 0, 0 };
const INT16 ColObjColScale[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
const UINT16 ColObjTblNameCol = 4;
const UINT16 ColObjColNameCol = 5;
const UINT16 ColObjPosCol = 6;
const UINT16 ColObjTypeCol = 7;
const UINT16 ColObjDataTypeCol = 8;
const UINT16 ColObjTypeNameCol = 9;
const UINT16 ColObjSubtypeCol = 10;
const UINT16 ColObjLenCol = 11;
const UINT16 ColObjPrecCol = 12;
const UINT16 ColObjScaleCol = 13;
const UINT16 ColObjNullCol = 14;
// getProcedureParams( )
const UINT16 ProcParamObjColCount = 14;
const UINT32 ProcParamObjColNameLen[] = { 5, 12, 11, 14, 10, 14, 10, 14, 13, 14, 12, 15, 11, 14 };
const pCHAR ProcParamObjColName[] = { "RECNO", "CATALOG_NAME", "SCHEMA_NAME", "PROCEDURE_NAME", "PARAM_NAME", "PARAM_POSITION", "PARAM_TYPE", "PARAM_DATATYPE", "PARAM_SUBTYPE", "PARAM_TYPENAME", "PARAM_LENGTH", "PARAM_PRECISION", "PARAM_SCALE", "PARAM_NULLABLE" };
const UINT16 ProcParamObjColType[] = { fldINT32, fldZSTRING, fldZSTRING, fldZSTRING, fldZSTRING, fldINT16, fldINT16, fldINT16, fldINT16, fldZSTRING, fldINT32, fldINT16, fldINT16, fldINT16 };
const UINT16 ProcParamObjColSubType[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
const INT32 ProcParamObjColLen[] = { 4, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 2, 2, 2, 2, 0, 4, 2, 2, 2 };
const INT16 ProcParamObjColPrec[] = { 0, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
const INT16 ProcParamObjColScale[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
const UINT16 ProcParamObjProcNameCol = 4;
const UINT16 ProcParamObjParamNameCol = 5;
const UINT16 ProcParamObjDataTypeCol = 8;
const UINT16 ProcParamObjLenCol = 11;
// getIndices( )
const UINT16 IdxObjColCount = 11;
const UINT32 IdxObjColNameLen[] = {5, 12, 11, 10, 10, 11, 15, 9, 10, 10, 6 };
const pCHAR IdxObjColName[] = { "RECNO", "CATALOG_NAME", "SCHEMA_NAME", "TABLE_NAME", "INDEX_NAME", "COLUMN_NAME", "COLUMN_POSITION", "PKEY_NAME", "INDEX_TYPE", "SORT_ORDER", "FILTER" };
const UINT16 IdxObjColType[] = { fldINT32, fldZSTRING, fldZSTRING, fldZSTRING, fldZSTRING, fldZSTRING, fldINT16, fldZSTRING, fldINT32, fldZSTRING, fldZSTRING };
const UINT16 IdxObjColSubType[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
const INT32 IdxObjColLen[] = { 4, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 2, UNKNOWN_COL_LENGTH, 4, 2, UNKNOWN_COL_LENGTH };
const INT16 IdxObjColPrec[] = { 0, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, UNKNOWN_COL_LENGTH, 0, UNKNOWN_COL_LENGTH, 0, 1, UNKNOWN_COL_LENGTH };
const INT16 IdxObjColScale[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
const UINT16 IdxObjTblNameCol = 4;
const UINT16 IdxObjIdxNameCol = 5;
const UINT16 IdxObjColNameCol = 6;
const UINT16 IdxObjColPosCol  = 7;
const UINT16 IdxObjKeyNameCol = 8;
const UINT16 IdxObjIdxTypeCol = 9;
const UINT16 IdxObjSortOrdCol = 10;
const UINT16 IdxObjFilterCol = 11;

enum eGetColumnAction
{
   eGetFromServer     = 0,  // retrieve data from server
   eUseNullString     = 1,  // use <NULL>
   eCalcLength        = 2,  // calculate length of column based on type
   eCalcPrecision     = 3,  // calculate precision of column based on type 
   eCalcScale         = 4,  // calculate scale of column based on type
   eUseParamName      = 5,  // use the ParamName member
   eCalcType          = 6,  // TableType, IndexType, ProcedureType, ColType
   eCalcDataType      = 7,  // calculate data type base
   eCalcSubtype       = 8,  // calculate data subtype base
   eCalcNullable      = 9,  // calculate IsNullable (0 or 1 )
   eCalcDataTypeName  = 10,  // get the data type name for columng
   eCalcAscDesc       = 11,  // return either 'A' or 'D'
   eSizeObjectName    = 12,  // size of MaxObjectName for server
   eCalcColPosition   = 13,  // get the Column Position for a param or column
   eCalcDatabase      = 14,  // get the DatabaseName
   eCalcTypeInfo      = 15,  // Calculate type info: eTable/eView/etc., eAutoInc/etc.
   eCalcParamType     = 16,  // Input/Output/inOut, etc.
   eGetRecno          = 17,  // Record # field
   eCalcPKeyName      = 18,  // Get Primary Key Name from Index Name
   eCalcIndexColNames = 19
};
enum eAddToQueryType
{
   eAddTypeNone     = 0,
   eAddTypeWhere    = 1,
   eAddTypeAnd      = 2,
   eAddTypeOr       = 3
};

void GetCommandError( pSQLCommand pCommand, pCHAR * ppszErrorMessage );
eAddToQueryType AddToQuery( pCHAR * ppszQuery, pCHAR pszToAdd, eAddToQueryType eType );
void AddFilter( pCHAR * ppszBase, pCHAR pszSourceFilter,
                                pCHAR pszInsert, eAddToQueryType eAddType );
void AddTableName( pCHAR * ppszBase, pCHAR pszScope, pCHAR pszTableNameFilter,
                                eAddToQueryType eType );
INT32 GetStandardColLengthFromAction( eGetColumnAction eAction, 
                                BOOL bPrecision, UINT16 uColumnNumber );
#endif
