# Hey Emacs, this is a -*- makefile -*-
########################
#  master include file for Delphi/C++Builder build tree

########################
#  common macros

ifeq "$(OS)" ""
   # if OS not set, then must be LINUX
  LINUX = 1
  WINE = 1
  TOOLEXT =
  PATHSEP = /
else
  WINDOWS = 1
  TOOLEXT = .exe
  PATHSEP = \\
endif

ifndef POSTFIX
  POSTFIX = _freeclx
endif

#os independent variables

BIN             = $(KYLIXDIR)$(PATHSEP)bin
DCUEXT		= .dcu
DEBUGDIR        = debug
OBJEXT          = .o
SLIBEXT         = .a
TOOLS           = $(FREECLX)$(PATHSEP)tools
UNITS           = $(FREECLX)$(PATHSEP)units
UNITSDEBUG      = $(FREECLX)$(PATHSEP)units$(PATHSEP)$(DEBUGDIR)

#os dependent variables
ifdef LINUX
  CAT             = cat
  CP              = cp
  COPY            = $(CP)
  CCDEBUGFLAGS    = -g
  DCC             = $(BIN)/dcc
  DEL             = rm
  DLIBEXT         = .so
  MV              = mv
  MOVE            = $(MV)
  MD              = mkdir -p
  PKGEXT          = .so
  PKGBPLPFX       = bpl
  PKGDCLPFX       = dcl
  RM	  	  = $(DEL) -f
  SLIBEXT_PIC	  = .pic.a
  OBJEXT_PIC      = .pic.o
  PICDCUEXT       = .dpu
endif

ifdef WINDOWS
  MV            = ren
  CP            = copy
  CAT           = $(TOOLS)\\cat
  CC            = $(BCB)\\bin\\bcc32
  CXX           = $(CC)
  COPY          = $(CP)
  DCC           =
  DEL           = del
  RM     	= $(DEL) -f
  MAKE          = $(TOOLS)\\make
  MESG          = $(TOOLS)\\mesg
  MOVE          = $(MV)
  MD            = mkdir
  PKGEXT        = .bpl
  PKGBPLPFX     =
  PKGDCLPFX     =
  SLIBEXT       = .lib
  SLIBEXT_PIC	= $(SLIBEXT)
  DLIBEXT       = .dll
endif

#.SUFFIXES	= .clean

PASDCUFILES     = $(subst Z,$(UNITS)/,$(PASFILES:.pas=.dcu))
PASDPUFILES     = $(subst Z,$(UNITS)/,$(PASFILES:.pas=.dpu))
DPKPACKAGEFILES = $(DPKFILES:.dpk=.package)
DEFAULTCLEAN	= $(subst Z,,$(PASFILES:.pas=.clean))
DPKCLEANFILES   = $(DPKFILES:.dpk=.clean)
RESCLEANFILES   = $(RESFILES:.res=.cleanres)
PASRESFILES	= $(RESFILES:.res=.resource);

%.package: %.dpk
	$(COPY) $(basename $<).dpk $(basename $<)$(POSTFIX).dpk
	perl -i.bak -p -e "s/\b$(basename $<)\b/$(basename $<)$(POSTFIX)/" $(basename $<)$(POSTFIX).dpk
ifdef MAKERTL
	perl -i.bak -p -e "s/\bbaseclx\b/baseclx$(POSTFIX)/" $(basename $<)$(POSTFIX).dpk
endif
ifdef MAKECLX
	perl -i.bak -p -e "s/\bvisualclx\b/visualclx$(POSTFIX)/" $(basename $<)$(POSTFIX).dpk
endif
	perl -i.bak -p -e "s/\bdataclx\b/dataclx$(POSTFIX)/" $(basename $<)$(POSTFIX).dpk
	$(COPY) $(basename $<).res $(basename $<)$(POSTFIX).res
	$(DCC) -m $(DCCFLAGS) -U$(UNITS) -q -DLINUX -H- -DMBCS -DDEVELOPERS -vn -le$(FREECLX)/bin -ln$(dir $<) $(DCCADDLFLAGS) $(basename $<)$(POSTFIX).dpk
	$(MOVE) $(FREECLX)/bin/$(PKGBPLPFX)$(basename $<)$(POSTFIX)$(PKGEXT) $(FREECLX)/bin/$(PKGBPLPFX)$(basename $<)$(POSTFIX)$(PKGEXT).$(PKGMAJVER).$(PKGMINVER)

%.resource: %.res
	$(CP) $< $(UNITS)

%.clean: %.pas
	-$(RM) $(UNITS)/$(basename $<).dcu
	-$(RM) $(UNITS)/$(basename $<).dpu

%.clean: %.dpk
	-$(RM) $(UNITS)/$(basename $<).res
	-$(RM) $(UNITS)/$(basename $<)$(POSTFIX)*
	-$(RM) $(FREECLX)/bin/$(PKGBPLPFX)$(basename $<)$(POSTFIX)*
	-$(RM) $(basename $<)$(POSTFIX).dpk*
	-$(RM) $(basename $<)$(POSTFIX).res

%.cleanres: %.res
	-$(RM) $(UNITS)/$<

