#!/usr/local/bin/perl

# Modify Kylix settings to search for FreeCLX units and packages.

$freeclx = $ENV{"FREECLX"};
$unitpath = $freeclx . "\/units\/debug:" . $freeclx . "\/units:";
@browsepaths = ( $freeclx . "\/rtl\/sys", $freeclx . "\/rtl\/linux",
   $freeclx . "\/clx", $freeclx . "\/dbclx", $freeclx . "\/dbxpress" );
$pathsep = ":";
$configname = $ENV{"HOME"} . "\/.borland\/delphi60rc";
$configbakname = $configname . "\.bak";

# Back up the existing configuration
@proglist = ( "cp", $configname, $configbakname );
system(@proglist) ;

# Read current configuration
if ( open( INFILE, $configname ) ) {
   @lines = <INFILE>;
   $count = @lines;
#   print( $lines );
} else {
   &configfileerror;
};
close( INFILE );

# Selectively modify entries if they do not already refer to FreeCLX paths
if ( open( OUTFILE, ">$configname" )) {
   $count = 0;
   while ($count <= @lines) {
      $line = $lines[$count];
      # Conditionally update Library path
      if ( $line =~ m/^Search Path=/ and not $line =~ m/$unitpath/ ) {
          $line =~ s/^Search Path=/Search Path=$unitpath:/;
      } else {
         # Conditionally update Browsing Path
         if ( $line =~ m/^Browsing Path=/ ) {
            foreach $bpath ( reverse @browsepaths) {
	       if ( not $line =~ m/$bpath/ ) {
	         $line =~ s/^Browsing Path=/Browsing Path=$bpath:/;
               };
            };
	 } else {
            # Conditionally update Package search path
            if ( $line =~ m/^Package Search Path=/ and not $line =~ m/$unitpath/ ) {
	       $line =~ s/^Package Search Path=/Package Search Path=$unitpath:/;
            };
	 };
      };
      print OUTFILE ( $line );
      $count++;
   }
} else {
   &configfileerror
};

sub configfileerror {
   print( "\nUnable to modify Kylix configuration file \"$configname\".\n",
          "Library and Search Paths not updated. Please update them manually ",
          "via the \"Tools | Environment Options | Library\" page in the ",
          "Kylix IDE.\n\n" );
   exit( 1 );
}

sub environment {
   print( "\nRequired environment not met.\n",
 	  "   FREECLX must point to the root of your FreeCLX installation, i.e.,\n",
	  "      export FREECLX=/home/user/freeclx\n",
          "   and\n",
	  "   KYLIXDIR must point to your Kylix installation directory, i.e.,\n",
	  "      export KYLIXDIR=/home/user/Kylix\n" );
  exit( 1 );
}

