/*************************************************************************** 
                                                                             
 Kylix and Delphi Cross-Platform Visual Component Library                    
                                                                             
 Copyright (c) 2000, 2001 Borland Software Corporation                      
                                                                             
 This file may be distributed and/or modified under the terms of the GNU     
 General Public License (GPL) version 2 as published by the Free Software    
 Software Foundation and appearing at http://www.borland.com/kylix/gpl.html. 
                                                                             
 Licensees holding a valid Borland No-Nonsense License for this Software may 
 use this file in accordance with such license, which appears in the file    
 license.txt that came with this Software.                                   
                                                                             
****************************************************************************/

#ifndef QCLXAPPLICATION_H
#define QCLXAPPLICATION_H

#include <qapplication.h>

#ifdef _WS_WIN_
#include <qt_windows.h>

typedef __stdcall int (*TWndProcHook) (MSG *);
static TWndProcHook WndProcHook = 0;
#endif

Q_EXPORT class QClxApplication : public QApplication
{
  public:
    QClxApplication(int &argc, char **argv) : QApplication(argc, argv) { }
#ifdef _WS_WIN_
    virtual bool winEventFilter(MSG *Message)
    {
      bool Result;

      Result = QApplication::winEventFilter(Message);
      if (WndProcHook)
        Result = ((*WndProcHook)(Message) && Result);
      return Result;
    }
    static TWndProcHook setWndProcHook(TWndProcHook WndProcPtr)
    {
      TWndProcHook old_hook = WndProcHook;
      WndProcHook = WndProcPtr;
      return old_hook;
    }
#endif
};

#endif /* QCLXAPPLICATION_H */
