/*************************************************************************** 
                                                                             
 Kylix and Delphi Cross-Platform Visual Component Library                    
                                                                             
 Copyright (c) 2000, 2001 Borland Software Corporation                       
                                                                             
 This file may be distributed and/or modified under the terms of the GNU     
 General Public License (GPL) version 2 as published by the Free Software    
 Software Foundation and appearing at http://www.borland.com/kylix/gpl.html. 
                                                                             
 Licensees holding a valid Borland No-Nonsense License for this Software may 
 use this file in accordance with such license, which appears in the file    
 license.txt that came with this Software.                                   
                                                                             
****************************************************************************/

#ifndef QCLXBITBTN_H
#define QCLXBITBTN_H

#include <qpushbutton.h>


class QClxBitBtn : public QPushButton {
  public:
    QClxBitBtn( QWidget *parent, const char *name, QHook paintCB ) : QPushButton( parent, name ) {
    	paint_event = paintCB;
    }

  protected:
    void drawButtonLabel( QPainter *p ) {
    	QRect r = style().pushButtonContentsRect( this );
    	typedef void (*func_type)(void *data, QPainterH p, QRectH r);  
    	(*(func_type)paint_event.func)(paint_event.data, (QPainterH)p, (QRectH)&r);
  }

  private:
    QHook paint_event;
    
};

#endif /* QCLXBITBTN_H */
