/*************************************************************************** 
                                                                             
 Kylix and Delphi Cross-Platform Visual Component Library                    
                                                                             
 Copyright (c) 2000, 2001 Borland Software Corporation                       
                                                                             
 This file may be distributed and/or modified under the terms of the GNU     
 General Public License (GPL) version 2 as published by the Free Software    
 Software Foundation and appearing at http://www.borland.com/kylix/gpl.html. 
                                                                             
 Licensees holding a valid Borland No-Nonsense License for this Software may 
 use this file in accordance with such license, which appears in the file    
 license.txt that came with this Software.                                   
                                                                             
****************************************************************************/

#ifndef QCLXOBJECTMAP_H
#define QCLXOBJECTMAP_H

#include <qobject.h>
#include <qdict.h>

class QClxObjectMap {
public:
  static void setAddCallback( void *ptr ) {
    addCallback = ptr;
  }

  static void setRemoveCallback( void *ptr ) {
    removeCallback = ptr;
  }

  static void add(void *obj, int value) {
    int exists =  (int)map.find( (int)obj );
    if ( exists && addCallback ) {
      typedef void (*func_type)(void *clxobj, void *handle);
      (*(func_type)addCallback)((void*)value, (void*)obj);
    }
    map.insert((int)obj, (void *)value);
    reverseMap.insert((int)value, (void*) obj);
  }

  static void remove(void *obj) {
    int reverseKey = (int)map.find( (int)obj );
    map.remove((int)obj);
    reverseMap.remove( (int)reverseKey );
    int value = (int)map.find( (int)obj );
    if ( value ) {
      typedef void (*func_type)(void *clxobj, void *handle);
      if ( removeCallback )
       (*(func_type)removeCallback)((void*)value, (void*)obj);
    }
  }

  static int find(void *obj) { return (int)map.find((int)obj); }

  static int findClxObject( void *obj ) { return (int)reverseMap.find( (int) obj); }

private:
  static void *addCallback;
  static void *removeCallback;
  static QIntDict<void> map;
  static QIntDict<void> reverseMap;
};


void *QClxObjectMap::addCallback;
void *QClxObjectMap::removeCallback;

QIntDict<void> QClxObjectMap::map;
QIntDict<void> QClxObjectMap::reverseMap;
#endif
