/*************************************************************************** 
                                                                             
 Kylix and Delphi Cross-Platform Visual Component Library                    
                                                                             
 Copyright (c) 2000, 2001 Borland Software Corporation                       
                                                                             
 This file may be distributed and/or modified under the terms of the GNU     
 General Public License (GPL) version 2 as published by the Free Software    
 Software Foundation and appearing at http://www.borland.com/kylix/gpl.html. 
                                                                             
 Licensees holding a valid Borland No-Nonsense License for this Software may 
 use this file in accordance with such license, which appears in the file    
 license.txt that came with this Software.                                   
                                                                            
****************************************************************************/

#ifndef QCXLSLIDER_H
#define QCLXSLIDER_H

#include <qslider.h>

class QClxSlider : public QSlider {
  public:
    QClxSlider( QWidget *parent, const char *name, QHookH drawTickCB ) : QSlider ( parent, name) {
      drawTick_event = drawTickCB;
    }
    void drawTicks( QPainter * p, const QColorGroup& cg , int dist, int w , int i ) const {
      p->setPen( cg.foreground() );
    	typedef void (*func_type)(void *data, QPainterH p, int dist, int w, int i);
    	(*(func_type)drawTick_event.func)(drawTick_event.data, (QPainterH)p, (int)dist, (int)w, (int)i);
    }
  private:
    QHookH drawTick_event;
};

#endif // QCLXSLIDER_H
