/*************************************************************************** 
                                                                             
 Kylix and Delphi Cross-Platform Visual Component Library                    
                                                                             
 Copyright (c) 2000, 2001 Borland Software Corporation                       
                                                                             
 This file may be distributed and/or modified under the terms of the GNU     
 General Public License (GPL) version 2 as published by the Free Software    
 Software Foundation and appearing at http://www.borland.com/kylix/gpl.html. 
                                                                             
 Licensees holding a valid Borland No-Nonsense License for this Software may 
 use this file in accordance with such license, which appears in the file    
 license.txt that came with this Software.                                   
                                                                             
****************************************************************************/

#ifndef QCLXSPINBOX_H
#define QCLXSPINBOX_H

#include <qspinbox.h>

class QClxSpinBox : public QSpinBox {
  public:
    QClxSpinBox( QWidget* parent = 0, const char *name = 0 ) : QSpinBox(parent, name) {};
    QClxSpinBox( int minValue, int maxValue, int step = 1,
      QWidget* parent = 0, const char* name = 0 ) : QSpinBox(minValue, maxValue, step, parent, name) {};

    QPushButton* upButton() const {return QSpinBox::upButton();}
    QPushButton* downButton() const {return QSpinBox::downButton();}
    QLineEdit* editor() const {return QSpinBox::editor();}
  private:
    bool isLeaving;
  protected:
    bool QClxSpinBox::eventFilter( QObject* obj, QEvent* ev ){
      isLeaving = (ev->type() == QEvent::Leave);
      return QSpinBox::eventFilter(obj, ev);
    }
    void QClxSpinBox::leaveEvent( QEvent* ) {
      QSpinBox::upButton()->setDown(FALSE);
      QSpinBox::downButton()->setDown(FALSE);
    }
    void QClxSpinBox::interpretText() {
      if (!isLeaving) {
        QSpinBox::interpretText();
      }
    }
};

#endif
