/*************************************************************************** 
                                                                             
 Kylix and Delphi Cross-Platform Visual Component Library                    
                                                                             
 Copyright (c) 2000, 2001 Borland Software Corporation                       
                                                                             
 This file may be distributed and/or modified under the terms of the GNU     
 General Public License (GPL) version 2 as published by the Free Software    
 Software Foundation and appearing at http://www.borland.com/kylix/gpl.html. 
                                                                             
 Licensees holding a valid Borland No-Nonsense License for this Software may 
 use this file in accordance with such license, which appears in the file    
 license.txt that came with this Software.                                   
                                                                             
****************************************************************************/

#ifndef QCLXSTYLE_H
#define QCLXSTYLE_H

/* base style class */
#include <qstyle.h>
                 
/* ancestor classes which should probably _not_ be instantiated */
#include <qcommonstyle.h>

/* style classes which implement a particular drawing style */
#include <qwindowsstyle.h>
#include <qmotifstyle.h>
#include <qcdestyle.h>
#include <qmotifplusstyle.h>
#include <qplatinumstyle.h>
#include <qsgistyle.h>

#include "../qtypes.h"
#include "../bindhelp.h"

class QClxStyleHooks {
  friend class QClxStyle;
  public:
    QClxStyleHooks() {
      polish_event.func = NULL;
      unPolish_event.func = NULL;
      polish2_event.func = NULL;
      unPolish2_event.func = NULL;
      polish3_event.func = NULL;
      itemRect_event.func = NULL;
      drawItem_event.func = NULL;
      drawSeparator_event.func = NULL;
      drawRect_event.func = NULL;
      drawRectStrong_event.func = NULL;
      drawButton_event.func = NULL;
      buttonRect_event.func = NULL;
      drawButtonMask_event.func = NULL;
      drawBevelButton_event.func = NULL;
      bevelButtonRect_event.func = NULL;
      drawToolButton_event.func = NULL;
      drawToolButton2_event.func = NULL;
      toolButtonRect_event.func = NULL;
      drawPanel_event.func = NULL;
      drawPopupPanel_event.func = NULL;
      drawArrow_event.func = NULL;
      drawExclusiveIndicator_event.func = NULL;
      drawExclusiveIndicatorMask_event.func = NULL;
      drawIndicator_event.func = NULL;
      drawIndicatorMask_event.func = NULL;
      drawFocusRect_event.func = NULL;
      drawComboButton_event.func = NULL;
      comboButtonRect_event.func = NULL;
      comboButtonFocusRect_event.func = NULL;
      drawComboButtonMask_event.func = NULL;
      drawPushButton_event.func = NULL;
      drawPushButtonLabel_event.func = NULL;
      pushButtonContentsRect_event.func = NULL;
      tabbarMetrics_event.func = NULL;
      drawTab_event.func = NULL;
      drawTabMask_event.func = NULL;
      scrollBarMetrics_event.func = NULL;
      drawScrollBarControls_event.func = NULL;
      drawSlider_event.func = NULL;
      drawSliderMask_event.func = NULL;
      drawSliderGroove_event.func = NULL;
      drawSliderGrooveMask_event.func = NULL;
      drawSplitter_event.func = NULL;
      drawCheckMark_event.func = NULL;
      polishPopupMenu_event.func = NULL;
      extraPopupMenuItemWidth_event.func = NULL;
      popupSubmenuIndicatorWidth_event.func = NULL;
      popupMenuItemHeight_event.func = NULL;
      drawPopupMenuItem_event.func = NULL;
      StyleDestroyed_event.func = NULL;
/*
      scrollBarPointOver_event.func = NULL;
      drawMenuBarItem_event.func = NULL;
      drawToolBarHandle_event.func = NULL;
*/
    }
    void hook_polish(QHook &hook) {
	  polish_event = hook;
    }
    void hook_unPolish(QHook &hook) {
      unPolish_event = hook;
    }
    void hook_polish2(QHook &hook) {
      polish2_event = hook;
    }
    void hook_unPolish2(QHook &hook) {
      unPolish2_event = hook;
    }
    void hook_polish3(QHook &hook) {
      polish3_event = hook;
    }
    void hook_itemRect(QHook &hook) {
      itemRect_event = hook;
    }
    void hook_drawItem(QHook &hook) {
      drawItem_event = hook;
    }
    void hook_drawSeparator(QHook &hook) {
      drawSeparator_event = hook;
    }
    void hook_drawRect(QHook &hook) {
      drawRect_event = hook;
    }
    void hook_drawRectStrong(QHook &hook) {
      drawRectStrong_event = hook;
    }
    void hook_drawButton(QHook &hook) {
      drawButton_event = hook;
    }
    void hook_buttonRect(QHook &hook) {
      buttonRect_event = hook;
    }
    void hook_drawButtonMask(QHook &hook) {
      drawButtonMask_event = hook;
    }
    void hook_drawBevelButton(QHook &hook) {
      drawBevelButton_event = hook;
    }
    void hook_bevelButtonRect(QHook &hook) {
      bevelButtonRect_event = hook;
    }
    void hook_drawToolButton(QHook &hook) {
      drawToolButton_event = hook;
    }
    void hook_drawToolButton2(QHook &hook) {
      drawToolButton2_event = hook;
    }
    void hook_toolButtonRect(QHook &hook) {
      toolButtonRect_event = hook;
    }
    void hook_drawPanel(QHook &hook) {
      drawPanel_event = hook;
    }
    void hook_drawPopupPanel(QHook &hook) {
      drawPopupPanel_event = hook;
    }
    void hook_drawArrow(QHook &hook) {
      drawArrow_event = hook;
    }
    void hook_drawExclusiveIndicator(QHook &hook) {
      drawExclusiveIndicator_event = hook;
    }
    void hook_drawExclusiveIndicatorMask(QHook &hook) {
      drawExclusiveIndicatorMask_event = hook;
    }
    void hook_drawIndicatorMask(QHook &hook) {
      drawIndicatorMask_event = hook;
    }
    void hook_drawIndicator(QHook &hook) {
      drawIndicator_event = hook;
    }
    void hook_drawFocusRect(QHook &hook) {
      drawFocusRect_event = hook;
    }
    void hook_drawComboButton(QHook &hook) {
      drawComboButton_event = hook;
    }
    void hook_comboButtonRect(QHook &hook) {
      comboButtonRect_event = hook;
    }
    void hook_comboButtonFocusRect(QHook &hook) {
      comboButtonFocusRect_event = hook;
    }
    void hook_drawComboButtonMask(QHook &hook) {
      drawComboButtonMask_event = hook;
    }
    void hook_drawPushButton(QHook &hook) {
      drawPushButton_event = hook;
    }
    void hook_drawPushButtonLabel(QHook &hook) {
      drawPushButtonLabel_event = hook;
    }
    void hook_pushButtonContentsRect(QHook &hook) {
      pushButtonContentsRect_event = hook;
    }
    void hook_tabbarMetrics(QHook &hook) {
      tabbarMetrics_event = hook;
    }
    void hook_drawTab(QHook &hook) {
      drawTab_event = hook;
    }
    void hook_drawTabMask(QHook &hook) {
      drawTabMask_event = hook;
    }
    void hook_scrollBarMetrics(QHook &hook) {
      scrollBarMetrics_event = hook;
    }
    void hook_drawScrollBarControls(QHook &hook) {
      drawScrollBarControls_event = hook;
    }
    void hook_drawSlider(QHook &hook) {
      drawSlider_event = hook;
    }
    void hook_drawSliderMask(QHook &hook) {
      drawSliderMask_event = hook;
    }
    void hook_drawSliderGroove(QHook &hook) {
      drawSliderGroove_event = hook;
    }
    void hook_drawSliderGrooveMask(QHook &hook) {
      drawSliderGrooveMask_event = hook;
    }
    void hook_drawSplitter(QHook &hook) {
      drawSplitter_event = hook;
    }
    void hook_drawCheckMark(QHook &hook) {
      drawCheckMark_event = hook;
    }
    void hook_polishPopupMenu(QHook &hook) {
      polishPopupMenu_event = hook;
    }
    void hook_extraPopupMenuItemWidth(QHook &hook) {
      extraPopupMenuItemWidth_event = hook;
    }
    void hook_popupSubmenuIndicatorWidth(QHook &hook) {
      popupSubmenuIndicatorWidth_event = hook;
    }
    void hook_popupMenuItemHeight(QHook &hook) {
      popupMenuItemHeight_event = hook;
    }
    void hook_drawPopupMenuItem(QHook &hook) {
      drawPopupMenuItem_event = hook;
    }

    void hook_StyleDestroyed(QHook &hook) {
      StyleDestroyed_event = hook;
    }
/*
    void hook_scrollBarPointOver(QHook &hook) {
      scrollBarPointOver_event = hook;
    }
    void hook_drawMenuBarItem_event(QHook &hook) {
      drawMenuBarItem_event = hook;
    }
    void hook_drawToolBarHandle_event(QHook &hook) {
      drawToolBarHandle_event = hook;
    }
*/
  private:
    QHook polish_event;
    QHook unPolish_event;
    QHook polish2_event;
    QHook unPolish2_event;
    QHook polish3_event;
    QHook itemRect_event;
    QHook drawItem_event;
    QHook drawSeparator_event;
    QHook drawRect_event;
    QHook drawRectStrong_event;
    QHook drawButton_event;
    QHook buttonRect_event;
    QHook drawButtonMask_event;
    QHook drawBevelButton_event;
    QHook bevelButtonRect_event;
    QHook drawToolButton_event;
    QHook drawToolButton2_event;
    QHook toolButtonRect_event;
    QHook drawPanel_event;
    QHook drawPopupPanel_event;
    QHook drawArrow_event;
    QHook drawExclusiveIndicator_event;
    QHook drawExclusiveIndicatorMask_event;
    QHook drawIndicatorMask_event;
    QHook drawIndicator_event;
    QHook drawFocusRect_event;
    QHook drawComboButton_event;
    QHook comboButtonRect_event;
    QHook comboButtonFocusRect_event;
    QHook drawComboButtonMask_event;
    QHook drawPushButton_event;
    QHook drawPushButtonLabel_event;
    QHook pushButtonContentsRect_event;
    QHook tabbarMetrics_event;
    QHook drawTab_event;
    QHook drawTabMask_event;
    QHook scrollBarMetrics_event;
    QHook drawScrollBarControls_event;
    QHook drawSlider_event;
    QHook drawSliderMask_event;
    QHook drawSliderGroove_event;
    QHook drawSliderGrooveMask_event;
    QHook drawSplitter_event;
    QHook drawCheckMark_event;
    QHook polishPopupMenu_event;
    QHook extraPopupMenuItemWidth_event;
    QHook popupSubmenuIndicatorWidth_event;
    QHook popupMenuItemHeight_event;
    QHook drawPopupMenuItem_event;
    QHook StyleDestroyed_event;
/*
    QHook scrollBarPointOver_event;
    QHook drawMenuBarItem_event;
    QHook drawToolBarHandle_event;
*/
};

#ifdef _WS_X11_
#define QCLX_ANCESTOR QPlatinumStyle
#endif
#ifdef _WS_WIN_
#define QCLX_ANCESTOR QWindowsStyle
#endif

/* QPlatinumStyle ancestor under linux */

class QClxStyle : public QCLX_ANCESTOR {
Q_OBJECT
  private:
    int FMaxSliderDragDistance;
    int FSplitterWidth;
    QSize FScrollBarExtent;
    QSize FIndicatorSize;
    QSize FExclusiveIndicatorSize;
    int FButtonShiftX;
    int FButtonShiftY;
    int FDefaultFrameWidth;
    int FSliderLength;
    QClxStyleHooks *hooks; /* callback hooks */
    QStyle *internalStyle; /* style for default drawing, able to be exchanged for other styles */

  private slots:
    void internalStyleDestroyed()
    {
      if (internalStyle)
      {
        internalStyle = NULL;
        delete this;
      }
    }

  public:
    void init()
    {
      /* set the internals to a decent default value */
      if (internalStyle == (QStyle*)this)
      {
        FMaxSliderDragDistance = QCLX_ANCESTOR::maximumSliderDragDistance();
        FSplitterWidth = QCLX_ANCESTOR::splitterWidth();
        FScrollBarExtent = QCLX_ANCESTOR::scrollBarExtent();
        FIndicatorSize = QCLX_ANCESTOR::indicatorSize();
        FExclusiveIndicatorSize = QCLX_ANCESTOR::exclusiveIndicatorSize();
        QCLX_ANCESTOR::getButtonShift(FButtonShiftX, FButtonShiftY);
        FDefaultFrameWidth = QCLX_ANCESTOR::defaultFrameWidth();
        FSliderLength = QCLX_ANCESTOR::sliderLength();
      }
      else
      {
        FMaxSliderDragDistance = internalStyle->maximumSliderDragDistance();
        FSplitterWidth = internalStyle->splitterWidth();
        FScrollBarExtent = internalStyle->scrollBarExtent();
        FIndicatorSize = internalStyle->indicatorSize();
        FExclusiveIndicatorSize = internalStyle->exclusiveIndicatorSize();
        internalStyle->getButtonShift(FButtonShiftX, FButtonShiftY);
        FDefaultFrameWidth = internalStyle->defaultFrameWidth();
        FSliderLength = internalStyle->sliderLength();
      }
    }
   
    /* constructors */
    QClxStyle(QStyle *aStyle, QClxStyleHooks *h) : QCLX_ANCESTOR()
    {
      if (!aStyle)
        internalStyle = this;
      else
      {
        internalStyle = aStyle;
        connect(internalStyle, SIGNAL(destroyed()),
          SLOT(internalStyleDestroyed()));
      }
      hooks = h;
      init();
    }

    QClxStyle(QString styleName, QClxStyleHooks *h) : QCLX_ANCESTOR()
    {
      if (styleName == "CDE")
        internalStyle = new QCDEStyle();
      else if (styleName == "MotifPlus")
        internalStyle = new QMotifStyle();
      else if (styleName == "Qt SGI")
        internalStyle = new QSGIStyle();
      else if (styleName == "Motif")
        internalStyle = new QMotifStyle();
      else if (styleName == "Platinum")
      #ifdef _WS_X11_
        internalStyle = this;
      #endif
      #ifdef _WS_WIN_
        internalStyle = new QPlatinumStyle();
      #endif
      else if (styleName == "Windows 95")
      #ifdef _WS_X11_
        internalStyle = new QWindowsStyle();
      #endif
      #ifdef _WS_WIN_
        internalStyle = this;
      #endif
      else
        internalStyle = this;

      if (internalStyle != (QStyle*)this)
        connect(internalStyle, SIGNAL(destroyed()),
        SLOT(internalStyleDestroyed()));
      hooks = h;
      init();
    }

    /* destructor */
    ~QClxStyle()
    {
      typedef void (*func_type)(void *data);
      QStyle *temp;

      temp = internalStyle;
      internalStyle = NULL;
      if (temp && (temp != (QStyle*)this))
        delete temp;

      if (hooks->StyleDestroyed_event.func)
        (*(func_type)hooks->StyleDestroyed_event.func)
          (hooks->StyleDestroyed_event.data);
      delete hooks;
    }

    void refresh(void)
    {
      QWidgetList *list = QApplication::allWidgets();
      QWidgetListIt it(*list);
      register QWidget *w;

      while( w = it.current() )
      {
        if (!w->testWFlags(WType_Desktop) && w->testWState(WState_Polished))
          polish(w);
        if (w->isVisible())
          w->update();
        ++it;
      }
      delete list; 
    }

    /*
      Reimplementation of abstract functions 
    */

    int defaultFrameWidth() const
    {
      return FDefaultFrameWidth;
    }

    void setDefaultFrameWidth(int Val)
    {
      FDefaultFrameWidth = Val;
    }

    int sliderLength() const
    {
      return FSliderLength;
    }

    void setSliderLength(int Val)
    {
      FSliderLength = Val;
    }

    int maximumSliderDragDistance() const
    {
      return FMaxSliderDragDistance;
    }

    void setMaximumSliderDragDistance(int Val)
    {
      FMaxSliderDragDistance = Val;
    }

    int splitterWidth() const
    {
      return FSplitterWidth;
    }

    void setSplitterWidth(int Val)
    {
      FSplitterWidth = Val;
    }

    QSize scrollBarExtent() const
    {
      return FScrollBarExtent;
    }

    void setScrollBarExtent(PSize Val)
    {
      FScrollBarExtent = *(QSize *)Val;
    }

    /* Check Boxes */
    QSize indicatorSize() const
    {
      return FIndicatorSize;
    }

    void setIndicatorSize(PSize Val)
    {
      FIndicatorSize = *(QSize *)Val;
    }

    /* Radio Buttons */
    QSize exclusiveIndicatorSize() const
    {
      return FExclusiveIndicatorSize;
    }

    void setExclusiveIndicatorSize(PSize Val)
    {
      FExclusiveIndicatorSize = *(QSize *)Val;
    }

    /* Push Buttons */
    void buttonShift( int &x, int &y )
    {
      x = FButtonShiftX;
      y = FButtonShiftY;
    }

    void setButtonShift(int x, int y)
    {
      FButtonShiftX = x;
      FButtonShiftY = y;
    }

    void scrollBarMetrics(const QScrollBar* p1, int& p2, int& p3, int& p4, int& p5)
    {
      typedef void (*func_type)(void *data, const QScrollBarH p1,
      int& p2, int& p3, int& p4, int& p5);

      if (internalStyle != (QStyle*)this)
        internalStyle->scrollBarMetrics(p1, p2, p3, p4, p5);
      else
        QCLX_ANCESTOR::scrollBarMetrics(p1, p2, p3, p4, p5);
      if ( hooks->scrollBarMetrics_event.func )
        (*(func_type)hooks->scrollBarMetrics_event.func)(hooks->scrollBarMetrics_event.data,
        (const QScrollBarH)p1, p2, p3, p4, p5);
    }

    void tabbarMetrics(const QTabBar* p1, int& p2, int& p3, int& p4)
    {
      typedef void (*func_type)(void *data, const QTabBarH p1, int* p2, int* p3, int* p4);

      if (internalStyle != (QStyle*)this)
        internalStyle->tabbarMetrics(p1, p2, p3, p4);
      else
        QCLX_ANCESTOR::tabbarMetrics(p1, p2, p3, p4);
      if ( hooks->tabbarMetrics_event.func )
       (*(func_type)hooks->tabbarMetrics_event.func)(hooks->tabbarMetrics_event.data, (const QTabBarH)p1, (int *)&p2, (int *)&p3, (int *)&p4);
    }

protected:
    //re-implement QStyle methods.
    void polish(QWidget* p1) {
      typedef void (*func_type)(void *data, QWidgetH p1);

      if ( hooks->polish_event.func )
        (*(func_type)hooks->polish_event.func)(hooks->polish_event.data, (QWidgetH)p1);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->polish(p1);
        else
          QCLX_ANCESTOR::polish(p1);
    }

    void unPolish(QWidget* p1) {
      typedef void (*func_type)(void *data, QWidgetH p1);

      if ( hooks->unPolish_event.func )
      {
        (*(func_type)hooks->unPolish_event.func)(hooks->unPolish_event.data, (QWidgetH)p1);
      }
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->unPolish(p1);
        else
          QCLX_ANCESTOR::unPolish(p1);
    }

    void polish(QApplication* p1) {
      typedef void (*func_type)(void *data, QApplicationH p1);

      if ( hooks->polish2_event.func )
	(*(func_type)hooks->polish2_event.func)(hooks->polish2_event.data, (QApplicationH)p1);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->polish(p1);
        else
          QCLX_ANCESTOR::polish(p1);
   }

    void unPolish(QApplication* p1) {
      typedef void (*func_type)(void *data, QApplicationH p1);

      if ( hooks->unPolish2_event.func )
        (*(func_type)hooks->unPolish2_event.func)(hooks->unPolish2_event.data, (QApplicationH)p1);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->unPolish(p1);
        else
          QCLX_ANCESTOR::unPolish(p1);
    }

    void polish(QPalette& p1) {
      typedef void (*func_type)(void *data, QPaletteH p1);

      if ( hooks->polish3_event.func )
        (*(func_type)hooks->polish3_event.func)(hooks->polish3_event.data, (QPaletteH)&p1);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->polish(p1);
        else
          QCLX_ANCESTOR::polish(p1);
    }

    QRect itemRect(QPainter* p, int x, int y, int w, int h, int flags, bool enabled, const QPixmap* pixmap, const QString& text, int len)
    {
      typedef void (*func_type)(void *data, QPainterH p, int &x, int &y, int &w, int &h, int flags, bool enabled, const QPixmapH pixmap, PWideString text, int len);

      if ( hooks->itemRect_event.func )
      {
        PWideString t_text;
        initializePWideString(t_text);
        copyQStringToPWideString(text, t_text);
        (*(func_type)hooks->itemRect_event.func)(hooks->itemRect_event.data, (QPainterH)p, x, y, w, h, flags, enabled, (const QPixmapH)pixmap, t_text, len);
	finalizePWideString(t_text);
	return QRect(x, y, w, h);
      }
      else
        if (internalStyle != (QStyle*)this)
          return internalStyle->itemRect(p, x, y, w, h, flags, enabled, pixmap, text, len);
        else
          return QCLX_ANCESTOR::itemRect(p, x, y, w, h, flags, enabled, pixmap, text, len);
    }

    void drawItem(QPainter* p, int x, int y, int w, int h, int flags, const QColorGroup& g, bool enabled, const QPixmap* pixmap, const QString& text, int len, const QColor* penColor)
    {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, int flags, const QColorGroupH g, bool enabled, const QPixmapH pixmap, PWideString text, int len, const QColorH penColor, DrawStage &stage);

      if ( hooks->drawItem_event.func )
      {
        DrawStage stage = Pre;
        PWideString t_text;
        initializePWideString(t_text);
        copyQStringToPWideString(text, t_text);
        (*(func_type)hooks->drawItem_event.func)(hooks->drawItem_event.data, (QPainterH)p, x, y, w, h, flags, (const QColorGroupH)&g, enabled, (const QPixmapH)pixmap, t_text, len, (const QColorH)penColor, stage);
        if ( stage == DefaultDraw )
          if (internalStyle != (QStyle*)this)
            internalStyle->drawItem(p, x, y, w, h, flags, g, enabled, pixmap, text, len, penColor);
          else
            QCLX_ANCESTOR::drawItem(p, x, y, w, h, flags, g, enabled, pixmap, text, len, penColor);
        stage = Post;
        (*(func_type)hooks->drawItem_event.func)(hooks->drawItem_event.data, (QPainterH)p, x, y, w, h, flags, (const QColorGroupH)&g, enabled, (const QPixmapH)pixmap, t_text, len, (const QColorH)penColor, stage);
        finalizePWideString(t_text);
      }
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawItem(p, x, y, w, h, flags, g, enabled, pixmap, text, len, penColor);
        else
          QCLX_ANCESTOR::drawItem(p, x, y, w, h, flags, g, enabled, pixmap, text, len, penColor);
    }

    void drawSeparator(QPainter* p, int x1, int y1, int x2, int y2, const QColorGroup& g, bool sunken, int lineWidth, int midLineWidth) {
      typedef void (*func_type)(void *data, QPainterH p, int x1, int y1, int x2, int y2, const QColorGroupH g, bool sunken, int lineWidth, int midLineWidth, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawSeparator_event.func )
	(*(func_type)hooks->drawSeparator_event.func)(hooks->drawSeparator_event.data, (QPainterH)p, x1, y1, x2, y2, (const QColorGroupH)&g, sunken, lineWidth, midLineWidth, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawSeparator(p, x1, y1, x2, y2, g, sunken, lineWidth, midLineWidth);
        else
          QCLX_ANCESTOR::drawSeparator(p, x1, y1, x2, y2, g, sunken, lineWidth, midLineWidth);
    }

    void drawRect(QPainter* p, int x, int y, int w, int h, const QColor& p6, int lineWidth, const QBrush* fill) {
      if ( hooks->drawRect_event.func ) {
        typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorH p6, int lineWidth, const QBrushH fill);
	    (*(func_type)hooks->drawRect_event.func)(hooks->drawRect_event.data, (QPainterH)p, x, y, w, h, (const QColorH)&p6, lineWidth, (const QBrushH)fill);
      }
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawRect(p, x, y, w, h, p6, lineWidth, fill);
        else
          QCLX_ANCESTOR::drawRect(p, x, y, w, h, p6, lineWidth, fill);
    }

    void drawRectStrong(QPainter* p, int x, int y, int w, int h, const QColorGroup& p6, bool sunken, int lineWidth, int midLineWidth, const QBrush* fill) {
      if ( hooks->drawRectStrong_event.func ) {
        typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH p6, bool sunken, int lineWidth, int midLineWidth, const QBrushH fill);
	    (*(func_type)hooks->drawRectStrong_event.func)(hooks->drawRectStrong_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&p6, sunken, lineWidth, midLineWidth, (const QBrushH)fill);
      }
      if (internalStyle != (QStyle*)this)
        internalStyle->drawRectStrong(p, x, y, w, h, p6, sunken, lineWidth, midLineWidth, fill);
      else
        QCLX_ANCESTOR::drawRectStrong(p, x, y, w, h, p6, sunken, lineWidth, midLineWidth, fill);
    }

    void drawButton(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, bool sunken, const QBrush* fill) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, bool sunken, const QBrushH fill, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawButton_event.func )
        (*(func_type)hooks->drawButton_event.func)(hooks->drawButton_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, sunken, (const QBrushH)fill, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawButton(p, x, y, w, h, g, sunken, fill);
        else
          QCLX_ANCESTOR::drawButton(p, x, y, w, h, g, sunken, fill);
    }

    QRect buttonRect(int x, int y, int w, int h) {
      typedef void (*func_type)(void *data, int &x, int &y, int &w, int &h);

      if ( hooks->buttonRect_event.func )
      {
        (*(func_type)hooks->buttonRect_event.func)(hooks->buttonRect_event.data, x, y, w, h);
        return QRect(x, y, w, h);
      }
      else
        if (internalStyle != (QStyle*)this)
          return (internalStyle->buttonRect(x, y, w, h));
        else
          return (QCLX_ANCESTOR::buttonRect(x, y, w, h)); 
    }

    void drawButtonMask(QPainter* p, int x, int y, int w, int h) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h);

      if ( hooks->drawButtonMask_event.func )
        (*(func_type)hooks->drawButtonMask_event.func)(hooks->drawButtonMask_event.data, (QPainterH)p, x, y, w, h);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawButtonMask(p, x, y, w, h);
        else
          QCLX_ANCESTOR::drawButtonMask(p, x, y, w, h);
    }

    void drawBevelButton(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, bool sunken, const QBrush* fill) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, bool sunken, const QBrushH fill, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawBevelButton_event.func )
        (*(func_type)hooks->drawBevelButton_event.func)(hooks->drawBevelButton_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, sunken, (const QBrushH)fill, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawBevelButton(p, x, y, w, h, g, sunken, fill);
        else
          QCLX_ANCESTOR::drawBevelButton(p, x, y, w, h, g, sunken, fill);
    }

    QRect bevelButtonRect(int x, int y, int w, int h) {
      typedef void (*func_type)(void *data, int &x, int &y, int &w, int &h);

      if ( hooks->bevelButtonRect_event.func )
      {
        (*(func_type)hooks->bevelButtonRect_event.func)(hooks->bevelButtonRect_event.data, x, y, w, h);
	return QRect(x, y, w, h);
      }
      else
        if (internalStyle != (QStyle*)this)
          return (internalStyle->bevelButtonRect(x, y, w, h));
        else
          return QCLX_ANCESTOR::bevelButtonRect(x, y, w, h);
    }

    void drawToolButton(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, bool sunken, const QBrush* fill) {
      if ( hooks->drawToolButton_event.func ) {
        typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, bool sunken, const QBrushH fill);
	    (*(func_type)hooks->drawToolButton_event.func)(hooks->drawToolButton_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, sunken, (const QBrushH)fill);
      }
      else 
        if (internalStyle != (QStyle*)this)
          internalStyle->drawToolButton(p, x, y, w, h, g, sunken, fill);
        else
          QCLX_ANCESTOR::drawToolButton(p, x, y, w, h, g, sunken, fill);
    }

    void drawToolButton(QToolButton* btn, QPainter* p) {
      if ( hooks->drawToolButton2_event.func ) {
        typedef void (*func_type)(void *data, QToolButtonH btn, QPainterH p);
	    (*(func_type)hooks->drawToolButton2_event.func)(hooks->drawToolButton2_event.data, (QToolButtonH)btn, (QPainterH)p);
      }
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawToolButton(btn, p);
        else
          QCLX_ANCESTOR::drawToolButton(btn, p);
    }

    QRect toolButtonRect(int x, int y, int w, int h) {
      if ( hooks->toolButtonRect_event.func ) {
        typedef QRectH (*func_type)(void *data, int x, int y, int w, int h);
	    return *(QRect*)(*(func_type)hooks->toolButtonRect_event.func)(hooks->toolButtonRect_event.data, x, y, w, h);
      }
      else
        if (internalStyle != (QStyle*)this)
          return (internalStyle->toolButtonRect(x, y, w, h));
        else
          return QCLX_ANCESTOR::toolButtonRect(x, y, w, h);
    }

    void drawPanel(QPainter* p, int x, int y, int w, int h, const QColorGroup& p6, bool sunken, int lineWidth, const QBrush* fill) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH p6, bool sunken, int lineWidth, const QBrushH fill, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawPanel_event.func )
        (*(func_type)hooks->drawPanel_event.func)(hooks->drawPanel_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&p6, sunken, lineWidth, (const QBrushH)fill, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawPanel(p, x, y, w, h, p6, sunken, lineWidth, fill);
        else
          QCLX_ANCESTOR::drawPanel(p, x, y, w, h, p6, sunken, lineWidth, fill);
    }

    void drawPopupPanel(QPainter* p, int x, int y, int w, int h, const QColorGroup& p6, int lineWidth, const QBrush* fill) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH p6, int lineWidth, const QBrushH fill, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawPopupPanel_event.func )
        (*(func_type)hooks->drawPopupPanel_event.func)(hooks->drawPopupPanel_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&p6, lineWidth, (const QBrushH)fill, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawPopupPanel(p, x, y, w, h, p6, lineWidth, fill);
        else
          QCLX_ANCESTOR::drawPopupPanel(p, x, y, w, h, p6, lineWidth, fill);
    }

    void drawArrow(QPainter* p, Qt::ArrowType type, bool down, int x, int y, int w, int h, const QColorGroup& g, bool enabled, const QBrush* fill) {
      typedef void (*func_type)(void *data, QPainterH p, ArrowType type, bool down, int x, int y, int w, int h, const QColorGroupH g, bool enabled, const QBrushH fill);

      if ( hooks->drawArrow_event.func )
        (*(func_type)hooks->drawArrow_event.func)(hooks->drawArrow_event.data, (QPainterH)p, (ArrowType)type, down, x, y, w, h, (const QColorGroupH)&g, enabled, (const QBrushH)fill);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawArrow(p, type, down, x, y, w, h, g, enabled, fill);
        else
          QCLX_ANCESTOR::drawArrow(p, type, down, x, y, w, h, g, enabled, fill);
    }

    void drawExclusiveIndicator(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, bool on, bool down, bool enabled) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, bool on, bool down, bool enabled, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawExclusiveIndicator_event.func )
	(*(func_type)hooks->drawExclusiveIndicator_event.func)(hooks->drawExclusiveIndicator_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, on, down, enabled, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawExclusiveIndicator(p, x, y, w, h, g, on, down, enabled);
        else
          QCLX_ANCESTOR::drawExclusiveIndicator(p, x, y, w, h, g, on, down, enabled);
    }

    void drawExclusiveIndicatorMask(QPainter* p, int x, int y, int w, int h, bool on) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, bool on);

      if ( hooks->drawExclusiveIndicatorMask_event.func )
        (*(func_type)hooks->drawExclusiveIndicatorMask_event.func)(hooks->drawExclusiveIndicatorMask_event.data, (QPainterH)p, x, y, w, h, on);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawExclusiveIndicatorMask(p, x, y, w, h, on);
        else
          QCLX_ANCESTOR::drawExclusiveIndicatorMask(p, x, y, w, h, on);
    }

    void drawIndicatorMask(QPainter* p, int x, int y, int w, int h, int state) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, int state);

      if ( hooks->drawIndicatorMask_event.func )
        (*(func_type)hooks->drawIndicatorMask_event.func)(hooks->drawIndicatorMask_event.data, (QPainterH)p, x, y, w, h, state);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawIndicatorMask(p, x, y, w, h, state);
        else
          QCLX_ANCESTOR::drawIndicatorMask(p, x, y, w, h, state);
    }

    void drawIndicator(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, int state, bool down, bool enabled) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, int state, bool down, bool enabled);

      DrawStage stage = Pre;
      if ( hooks->drawIndicator_event.func )
        (*(func_type)hooks->drawIndicator_event.func)(hooks->drawIndicator_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, state, down, enabled);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawIndicator(p, x, y, w, h, g, state, down, enabled);
        else
          QCLX_ANCESTOR::drawIndicator(p, x, y, w, h, g, state, down, enabled);
    }

    void drawFocusRect(QPainter* p1, const QRect& p2, const QColorGroup& p3, const QColor* bg, bool p5) {
      typedef void (*func_type)(void *data, QPainterH p1, const QRectH p2, const QColorGroupH p3, const QColorH bg, bool p5, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawFocusRect_event.func )
        (*(func_type)hooks->drawFocusRect_event.func)(hooks->drawFocusRect_event.data, (QPainterH)p1, (const QRectH)&p2, (const QColorGroupH)&p3, (const QColorH)bg, p5, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawFocusRect(p1, p2, p3, bg, p5);
        else
          QCLX_ANCESTOR::drawFocusRect(p1, p2, p3, bg, p5);
    }

    void drawComboButton(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, bool sunken, bool editable, bool enabled, const QBrush* fill) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, bool sunken, bool editable, bool enabled, const QBrushH fill, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawComboButton_event.func )
        (*(func_type)hooks->drawComboButton_event.func)(hooks->drawComboButton_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, sunken, editable, enabled, (const QBrushH)fill, stage);
      else
        stage = DefaultDraw;
      if (stage == DefaultDraw)
        if (internalStyle != (QStyle*)this)
          internalStyle->drawComboButton(p, x, y, w, h, g, sunken, editable, enabled, fill);
        else
          QCLX_ANCESTOR::drawComboButton(p, x, y, w, h, g, sunken, editable, enabled, fill);
    }

    QRect comboButtonRect(int x, int y, int w, int h) {
      typedef void (*func_type)(void *data, int &x, int &y, int &w, int &h);

      if ( hooks->comboButtonRect_event.func )
      {
        (*(func_type)hooks->comboButtonRect_event.func)(hooks->comboButtonRect_event.data, x, y, w, h);
        return QRect(x, y, w, h);
      }
      else
        if (internalStyle != (QStyle*)this)
          return (internalStyle->comboButtonRect(x, y, w, h));
        else
          return QCLX_ANCESTOR::comboButtonRect(x, y, w, h);
    }

    QRect comboButtonFocusRect(int x, int y, int w, int h) {
      typedef void (*func_type)(void *data, int &x, int &y, int &w, int &h);

      if ( hooks->comboButtonFocusRect_event.func )
      {
        (*(func_type)hooks->comboButtonFocusRect_event.func)(hooks->comboButtonFocusRect_event.data, x, y, w, h);
        return QRect(x, y, w, h);
      }
      else
        if (internalStyle != (QStyle*)this)
          return (internalStyle->comboButtonFocusRect(x, y, w, h));
        else
          return QCLX_ANCESTOR::comboButtonFocusRect(x, y, w, h);
    }

    void drawComboButtonMask(QPainter* p, int x, int y, int w, int h) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h);

      if ( hooks->drawComboButtonMask_event.func )
        (*(func_type)hooks->drawComboButtonMask_event.func)(hooks->drawComboButtonMask_event.data, (QPainterH)p, x, y, w, h);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawComboButtonMask(p, x, y, w, h);
        else
          QCLX_ANCESTOR::drawComboButtonMask(p, x, y, w, h);
    }

    void drawPushButton(QPushButton* btn, QPainter* p) {
      typedef void (*func_type)(void *data, QPushButtonH btn, QPainterH p, DrawStage& stage);

      DrawStage stage = Pre;
      if ( hooks->drawPushButton_event.func )
        (*(func_type)hooks->drawPushButton_event.func)(hooks->drawPushButton_event.data, (QPushButtonH)btn, (QPainterH)p, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawPushButton(btn, p);
        else
          QCLX_ANCESTOR::drawPushButton(btn, p);
      stage = Post;
      if ( hooks->drawPushButton_event.func )
        (*(func_type)hooks->drawPushButton_event.func)(hooks->drawPushButton_event.data, (QPushButtonH)btn, (QPainterH)p, stage);
    }

    void drawPushButtonLabel(QPushButton* btn, QPainter* p) {
      typedef void (*func_type)(void *data, QPushButtonH btn, QPainterH p, DrawStage& stage);

      DrawStage stage = Pre;
      if ( hooks->drawPushButtonLabel_event.func )
        (*(func_type)hooks->drawPushButtonLabel_event.func)(hooks->drawPushButtonLabel_event.data, (QPushButtonH)btn, (QPainterH)p, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawPushButtonLabel(btn, p);
        else
          QCLX_ANCESTOR::drawPushButtonLabel(btn, p);
    }

    QRect pushButtonContentsRect(QPushButton* btn)
    {
      typedef QRectH (*func_type)(void *data, QPushButtonH btn);

      if ( hooks->pushButtonContentsRect_event.func )
        return *(QRect*)(*(func_type)hooks->pushButtonContentsRect_event.func)(hooks->pushButtonContentsRect_event.data, (QPushButtonH)btn);
      else
        if (internalStyle != (QStyle*)this)
          return (internalStyle->pushButtonContentsRect(btn));
        else
          return QCLX_ANCESTOR::pushButtonContentsRect(btn);
    }

    void drawTab(QPainter* p1, const QTabBar* p2, QTab* p3, bool selected)
    {
      typedef void (*func_type)(void *data, QPainterH p1, const QTabBarH p2, int index, bool selected);

      if ( hooks->drawTab_event.func ) {
        int index = -1;
        for ( int i = 0; const_cast<QTabBar*>(p2)->tab( i ) != 0; i++ )
          if ( const_cast<QTabBar*>(p2)->tab( i ) == p3 )
          {
            index = i;
            break;
          }

        (*(func_type)hooks->drawTab_event.func)(hooks->drawTab_event.data, (QPainterH)p1, (const QTabBarH)p2, index, selected);
      }
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawTab(p1, p2, p3, selected);
        else
          QCLX_ANCESTOR::drawTab(p1, p2, p3, selected);
    }

    void drawTabMask(QPainter* p1, const QTabBar* p2, QTab* p3, bool selected)
    {
      typedef void (*func_type)(void *data, QPainterH p1, const QTabBarH p2, int index, bool selected);

      if ( hooks->drawTabMask_event.func ) {
        int index = -1;
        for ( int i = 0; const_cast<QTabBar*>(p2)->tab( i ) != 0; i++ )
          if ( const_cast<QTabBar*>(p2)->tab( i ) == p3 ) {
            index = i;
            break;
          }
        (*(func_type)hooks->drawTabMask_event.func)(hooks->drawTabMask_event.data, (QPainterH)p1, (const QTabBarH)p2, index, selected);
      }
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawTabMask(p1, p2, p3, selected);
        else
          QCLX_ANCESTOR::drawTabMask(p1, p2, p3, selected);
    }

    void drawScrollBarControls(QPainter* p1, const QScrollBar* p2, int sliderStart, uint controls, uint activeControl) {
      typedef void (*func_type)(void *data, QPainterH p1, const QScrollBarH p2,
        int sliderStart, uint controls, uint activeControl, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawScrollBarControls_event.func )
        (*(func_type)hooks->drawScrollBarControls_event.func)(hooks->drawScrollBarControls_event.data, (QPainterH)p1, (const QScrollBarH)p2, sliderStart, controls, activeControl, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawScrollBarControls(p1, p2, sliderStart, controls, activeControl);
        else
          QCLX_ANCESTOR::drawScrollBarControls(p1, p2, sliderStart, controls, activeControl);
    }

    void drawSlider(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, Orientation p7, bool tickAbove, bool tickBelow) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, Orientation p7, bool tickAbove, bool tickBelow, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawSlider_event.func )
        (*(func_type)hooks->drawSlider_event.func)(hooks->drawSlider_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, p7, tickAbove, tickBelow, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawSlider(p, x, y, w, h, g, p7, tickAbove, tickBelow);
        else
          QCLX_ANCESTOR::drawSlider(p, x, y, w, h, g, p7, tickAbove, tickBelow);
    }

    void drawSliderMask(QPainter* p, int x, int y, int w, int h, Orientation p6, bool tickAbove, bool tickBelow) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, Orientation p6, bool tickAbove, bool tickBelow);

      if ( hooks->drawSliderMask_event.func )
        (*(func_type)hooks->drawSliderMask_event.func)(hooks->drawSliderMask_event.data, (QPainterH)p, x, y, w, h, p6, tickAbove, tickBelow);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawSliderMask(p, x, y, w, h, p6, tickAbove, tickBelow);
        else
          QCLX_ANCESTOR::drawSliderMask(p, x, y, w, h, p6, tickAbove, tickBelow);
    }

    void drawSliderGroove(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, QCOORD c, Orientation p8) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, QCOORD c, Orientation p8, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawSliderGroove_event.func )
        (*(func_type)hooks->drawSliderGroove_event.func)(hooks->drawSliderGroove_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, c, p8, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawSliderGroove(p, x, y, w, h, g, c, p8);
        else
          QCLX_ANCESTOR::drawSliderGroove(p, x, y, w, h, g, c, p8);
    }

    void drawSliderGrooveMask(QPainter* p, int x, int y, int w, int h, QCOORD c, Orientation p7) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, QCOORD c, Orientation p7);

      if ( hooks->drawSliderGrooveMask_event.func )
        (*(func_type)hooks->drawSliderGrooveMask_event.func)(hooks->drawSliderGrooveMask_event.data, (QPainterH)p, x, y, w, h, c, p7);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawSliderGrooveMask(p, x, y, w, h, c, p7);
        else
          QCLX_ANCESTOR::drawSliderGrooveMask(p, x, y, w, h, c, p7);
    }

    void drawSplitter(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, Orientation p7) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, Orientation p7, DrawStage &stage);

      DrawStage stage = Pre;
      if ( hooks->drawSplitter_event.func )
        (*(func_type)hooks->drawSplitter_event.func)(hooks->drawSplitter_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, p7, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawSplitter(p, x, y, w, h, g, p7);
        else
          QCLX_ANCESTOR::drawSplitter(p, x, y, w, h, g, p7);
    }

    void drawCheckMark(QPainter* p, int x, int y, int w, int h, const QColorGroup& g, bool act, bool dis) {
      typedef void (*func_type)(void *data, QPainterH p, int x, int y, int w, int h, const QColorGroupH g, bool act, bool dis);

      if ( hooks->drawCheckMark_event.func )
       (*(func_type)hooks->drawCheckMark_event.func)(hooks->drawCheckMark_event.data, (QPainterH)p, x, y, w, h, (const QColorGroupH)&g, act, dis);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->drawCheckMark(p, x, y, w, h, g, act, dis);
        else
          QCLX_ANCESTOR::drawCheckMark(p, x, y, w, h, g, act, dis);
    }

    void polishPopupMenu(QPopupMenu* p1) {
      typedef void (*func_type)(void *data, QPopupMenuH p1);

      if ( hooks->polishPopupMenu_event.func )
        (*(func_type)hooks->polishPopupMenu_event.func)(hooks->polishPopupMenu_event.data, (QPopupMenuH)p1);
      else
        if (internalStyle != (QStyle*)this)
          internalStyle->polishPopupMenu(p1);
        else
          QCLX_ANCESTOR::polishPopupMenu(p1);
    }

    int extraPopupMenuItemWidth(bool checkable, int maxpmw, QMenuItem* mi, const QFontMetrics& fm) {
      typedef void (*func_type)(void *data, bool checkable, int maxpmw, QMenuItemH mi, const QFontMetricsH fm, int &retval);

      int retval;

      if (internalStyle != (QStyle*)this)
        retval = internalStyle->extraPopupMenuItemWidth(checkable, maxpmw, mi, fm);
      else
        retval = QCLX_ANCESTOR::extraPopupMenuItemWidth(checkable, maxpmw, mi, fm);
      if ( hooks->extraPopupMenuItemWidth_event.func )
        (*(func_type)hooks->extraPopupMenuItemWidth_event.func)(hooks->extraPopupMenuItemWidth_event.data, checkable, maxpmw, (QMenuItemH)mi, (const QFontMetricsH)&fm, retval);

      return retval;
    }

    int popupSubmenuIndicatorWidth(const QFontMetrics& fm) {
      typedef void (*func_type)(void *data, const QFontMetricsH fm, int &retval);

      int retval;

      if (internalStyle != (QStyle*)this)
        retval = internalStyle->popupSubmenuIndicatorWidth(fm);
      else
        retval = QCLX_ANCESTOR::popupSubmenuIndicatorWidth(fm);
      if ( hooks->popupSubmenuIndicatorWidth_event.func )
        (*(func_type)hooks->popupSubmenuIndicatorWidth_event.func)(hooks->popupSubmenuIndicatorWidth_event.data, (const QFontMetricsH)&fm, retval);
      return retval;
    }

    int popupMenuItemHeight(bool checkable, QMenuItem* mi, const QFontMetrics& fm) {
      typedef int (*func_type)(void *data, bool checkable, QMenuItemH mi, const QFontMetricsH fm, int &retval);

      int retval;

      if (internalStyle != (QStyle*)this)
        retval = internalStyle->popupMenuItemHeight(checkable, mi, fm);
      else
        retval = QCLX_ANCESTOR::popupMenuItemHeight(checkable, mi, fm);
      if ( hooks->popupMenuItemHeight_event.func )
        (*(func_type)hooks->popupMenuItemHeight_event.func)(hooks->popupMenuItemHeight_event.data, checkable, (QMenuItemH)mi, (const QFontMetricsH)&fm, retval);
      return retval;
    }

    void drawPopupMenuItem(QPainter* p, bool checkable, int maxpmw, int tab, QMenuItem* mi, const QPalette& pal, bool act, bool enabled, int x, int y, int w, int h) {
      typedef void (*func_type)(void *data, QPainterH p, bool checkable, int maxpmw, int tab, QMenuItemH mi, int itemID, bool act, bool enabled, int x, int y, int w, int h, DrawStage &stage);

      DrawStage stage = Pre;
      int itemID = 0;
      if ( mi )
        itemID = mi->id();
      if ( hooks->drawPopupMenuItem_event.func )
        (*(func_type)hooks->drawPopupMenuItem_event.func)(hooks->drawPopupMenuItem_event.data, (QPainterH)p, checkable, maxpmw, tab, (QMenuItemH)mi, itemID, act, enabled, x, y, w, h, stage);
      else
        stage = DefaultDraw;
      if ( stage == DefaultDraw )
        if (internalStyle != (QStyle*)this)
          internalStyle->drawPopupMenuItem(p, checkable, maxpmw, tab, mi, pal, act, enabled, x, y, w, h);
        else
          QCLX_ANCESTOR::drawPopupMenuItem(p, checkable, maxpmw, tab, mi, pal, act, enabled, x, y, w, h);

      stage = Post;
      if ( hooks->drawPopupMenuItem_event.func )
        (*(func_type)hooks->drawPopupMenuItem_event.func)(hooks->drawPopupMenuItem_event.data, (QPainterH)p, checkable, maxpmw, tab, (QMenuItemH)mi, itemID, act, enabled, x, y, w, h, stage);
    }

    ScrollControl scrollBarPointOver( const QScrollBar* sb,
		                      int sliderStart, const QPoint& Point) {
      if (internalStyle != (QStyle*)this)
        return internalStyle->scrollBarPointOver(sb, sliderStart, Point);
      else
        return QCLX_ANCESTOR::scrollBarPointOver(sb, sliderStart, Point);
    }

    void drawMenuBarItem(QPainter* p, int x, int y, int w, int h,
			 QMenuItem* mi, QColorGroup& g, bool enabled, bool active )
    {
      if (internalStyle != (QStyle *)this)
        internalStyle->drawMenuBarItem(p, x, y, w, h, mi, g, enabled, active);
      else
        QCLX_ANCESTOR::drawMenuBarItem(p, x, y, w, h, mi, g, enabled, active);
    }
    void drawToolBarHandle(QPainter *p, const QRect &r,
                           Qt::Orientation orientation,
                           bool highlight, const QColorGroup &cg,
                           bool drawBorder = FALSE)
    {
      if (internalStyle != (QStyle*)this)
        internalStyle->drawToolBarHandle(p, r, orientation, highlight, cg, drawBorder);
      else
        QCLX_ANCESTOR::drawToolBarHandle(p, r, orientation, highlight, cg, drawBorder);
    }
};

#undef QCLX_ANCESTOR

#include "qclxstyle.moc"

#endif /* QCLXSTYLE_H */

