#ifndef QOPENTABLEVIEW_H
#define QOPENTABLEVIEW_H

#include <qtableview.h>

class Q_EXPORT QOpenTableView : public QTableView {
  public:
    int		numRows()	const { return QTableView::numRows(); }
    virtual void setNumRows( int r ) { QTableView::setNumRows( r ); }
    int		numCols()	const { return QTableView::numCols(); }
    virtual void setNumCols( int c ) { QTableView::setNumCols( c ); }

    int		topCell()	const { return QTableView::topCell(); }
    virtual void setTopCell( int row ) { QTableView::setTopCell( row ); }
    int		leftCell()	const { return QTableView::leftCell(); }
    virtual void setLeftCell( int col ) { QTableView::setLeftCell( col ); }
    virtual void setTopLeftCell( int row, int col ) { QTableView::setTopLeftCell( row, col ); }

    int		xOffset()	const { return QTableView::xOffset(); }
    virtual void setXOffset( int xofs ) { QTableView::setXOffset( xofs ); }
    int		yOffset()	const { return QTableView::yOffset(); }
    virtual void setYOffset( int yofs ) { QTableView::setYOffset( yofs ); }
    virtual void setOffset( int x, int y, bool updateScrBars = TRUE ) {
      QTableView::setOffset( x, y, updateScrBars ); }

    virtual int cellWidth( int col ) { return QTableView::cellWidth( col ); }
    virtual int cellHeight( int row ) { return QTableView::cellHeight( row ); }
    int		cellWidth()	const { return QTableView::cellWidth(); }
    int		cellHeight()	const { return QTableView::cellHeight(); }
    virtual void setCellWidth( int w ) { QTableView::setCellWidth( w ); }
    virtual void setCellHeight( int h ) { QTableView::setCellHeight( h ); }

    virtual int totalWidth() { return QTableView::totalWidth(); }
    virtual int totalHeight() { return QTableView::totalHeight(); }

    uint	tableFlags() const { return QTableView::tableFlags(); }
    bool	testTableFlags( uint f ) const { return QTableView::testTableFlags( f ); }
    virtual void 	setTableFlags( uint f ) { QTableView::setTableFlags( f ); }
    void	clearTableFlags( uint f = ~0 ) { QTableView::clearTableFlags( f ); } 
 
    bool	autoUpdate()	 const { return QTableView::autoUpdate(); }
    virtual void setAutoUpdate( bool b ) { QTableView::setAutoUpdate( b ); }

    void	updateCell( int row, int column, bool erase=TRUE ) {
      QTableView::updateCell( row, column, erase ); }

    QRect	cellUpdateRect() const { return QTableView::cellUpdateRect(); }
    QRect	viewRect()	 const { return QTableView::viewRect(); }

    int		lastRowVisible() const { return QTableView::lastRowVisible(); }
    int		lastColVisible() const { return QTableView::lastColVisible(); }

    bool	rowIsVisible( int row ) const { return QTableView::rowIsVisible( row ); }
    bool	colIsVisible( int col ) const { return QTableView::colIsVisible( col ); }

    QScrollBar *verticalScrollBar() const { return QTableView::verticalScrollBar(); }
    QScrollBar *horizontalScrollBar() const { return QTableView::horizontalScrollBar(); }
    
    void	scroll( int xPixels, int yPixels ) { QTableView::scroll( xPixels, yPixels ); }
    void	updateScrollBars() { QTableView::updateScrollBars(); }
    void	updateTableSize() { QTableView::updateTableSize(); }


};

#endif
