#ifndef QOpenWidget_H
#define QOpenWidget_H

#include <qwidget.h>

class QOpenWidget: public QWidget {
  public:
    // Declare all event handlers as public
            bool event( QEvent * e) { return QWidget::event(e); }
    virtual void mousePressEvent( QMouseEvent *e ) { QWidget::mousePressEvent(e); }
    virtual void mouseReleaseEvent( QMouseEvent *e ) { QWidget::mouseReleaseEvent(e); }
    virtual void mouseDoubleClickEvent( QMouseEvent *e ) { QWidget::mouseDoubleClickEvent(e); }
    virtual void mouseMoveEvent( QMouseEvent *e ) { QWidget::mouseMoveEvent(e); }
    virtual void wheelEvent( QWheelEvent *e ) { QWidget::wheelEvent(e); }
    virtual void keyPressEvent( QKeyEvent *e ) { QWidget::keyPressEvent(e); }
    virtual void keyReleaseEvent( QKeyEvent *e ) { QWidget::keyReleaseEvent(e); }
    virtual void focusInEvent( QFocusEvent *e ) { QWidget::focusInEvent(e); }
    virtual void focusOutEvent( QFocusEvent *e ) { QWidget::focusOutEvent(e); }
    virtual void enterEvent( QEvent *e ) { QWidget::enterEvent(e); }
    virtual void leaveEvent( QEvent *e ) { QWidget::leaveEvent(e); }
    virtual void paintEvent( QPaintEvent *e ) { QWidget::paintEvent(e); }
    virtual void moveEvent( QMoveEvent *e ) { QWidget::moveEvent(e); }
    virtual void resizeEvent( QResizeEvent *e ) { QWidget::resizeEvent(e); }
    virtual void closeEvent( QCloseEvent *e ) { QWidget::closeEvent(e); }

    virtual void dragEnterEvent( QDragEnterEvent *e ) { QWidget::dragEnterEvent(e); }
    virtual void dragMoveEvent( QDragMoveEvent *e ) { QWidget::dragMoveEvent(e); }
    virtual void dragLeaveEvent( QDragLeaveEvent *e ) { QWidget::dragLeaveEvent(e); }
    virtual void dropEvent( QDropEvent *e ) { QWidget::dropEvent(e); }

    virtual void showEvent( QShowEvent *e ) { QWidget::showEvent(e); }
    virtual void hideEvent( QHideEvent *e ) { QWidget::hideEvent(e); }
    virtual void customEvent( QCustomEvent *e ) { QWidget::customEvent(e); }

    // declare utility methods public
    uint	 getWState() const { return QWidget::getWState(); }
    virtual void setWState( uint n ) { QWidget::setWState(n); }
    void	 clearWState( uint n ) { QWidget::clearWState(n); }
    WFlags	 getWFlags() const { return QWidget::getWFlags(); }
    virtual void setWFlags( WFlags n ) { QWidget::setWFlags(n); }
    void	 clearWFlags( WFlags n ) { QWidget::clearWFlags(n); }

    virtual bool focusNextPrevChild( bool next ) { return focusNextPrevChild(next); }
    
    void updateMask() { QWidget::updateMask(); }
};

#endif