$cheader_base = "\t\$(PERL) moc_cheader.pl ";
$cheader_tail = " > \$@\n";
$cimpl_base = "\t\$(PERL) moc_cimpl.pl ";
$cimpl_tail = " > \$@\n";
$pintf_base = "\t\$(BINDGEN) -PascalIntf ";
$pintf_tail = " > \$@\n";
$pimpl_base = "\t\$(BINDGEN) -PascalImpl ";
$pimpl_tail = " > \$@\n";

while(<>) {
  chomp;
  @line = split(/[~&@,-]/);
  SWITCH: {
    if ( /\~/ ) {
      if ($boundary ne "") {
        print "# Change enum names\n";
        print $cheader_rule;
        print "\n";
        print $cimpl_rule;
        print "\n";
        print $pintf_rule;
        print "\n";
        print $pimpl_rule;
        print "\n";
      }

      $boundary = "\n\n";
      $class = @line[1];
      chomp $class;
      $file = $class;
      $file =~ tr/[A-Z]/[a-z]/;
      $file = @line[2] if $#line > 1;
      $file =~ s/ // if $#line > 1;
      $depend_file = "include/".$file.".h";
      $depend = ": ".$depend_file."\n";
      $cheader_rule = "lib/".$file.".hb".$depend.$cheader_base.$depend_file.$cheader_tail;
      $cimpl_rule = "lib/".$file.".cpp".$depend.$cimpl_base.$depend_file.$cimpl_tail;
      $pintf_rule = "rtl/".$file.".inci".$depend.$pintf_base.$depend_file.$pintf_tail;
      $pimpl_rule = "rtl/".$file.".incm".$depend.$pimpl_base.$depend_file.$pimpl_tail;

      last SWITCH;
    }
    if ( /\&/ ) {
      @line[2] = $class if $#line < 2;
      @line[2] =~ s/ //g;
      $replacecpp = "\t\$(PERL_IPE) \"s/\\b".@line[1]."\\b/".@line[2]."_".$line[1]."/g\" \$@\n";
      $replacepas = "\t\$(PERL_IPE) \"s/\\b".@line[1]."\\b/".@line[2].$line[1]."/g\" \$@\n";
      $cheader_rule = $cheader_rule.$replacecpp;
      $cimpl_rule = $cimpl_rule.$replacecpp;
      $pintf_rule = $pintf_rule.$replacepas;
      $pimpl_rule = $pimpl_rule.$replacepas;
      last SWITCH;
    }
    if ( /\@/ ) {
      $func_name = @line[1];
      $t = $func_name;
      $t =~ tr/A-Z/a-z/;
      $func_name = substr($t,0,1).substr($func_name,1);
      $replace_func = "\t\$(PERL_IPE) \"s/\\b".$class."_".$func_name."\\b/".$class."_get".@line[1]."/g\" \$@\n";
      $replace_var = "\t\$(PERL_IPE) \"s/\\b".@line[1]."\\b/".$class."_".$line[1]."/g\" \$@\n";
      $cheader_rule = $cheader_rule.$replace_var;
      $cimpl_rule = $cimpl_rule.$replace_var;
      $pintf_rule = $pintf_rule.$replace_func.$replace_var;
      $pimpl_rule = $pimpl_rule.$replace_func.$replace_var;

      last SWITCH;
    }
    if ( /\-/ ) {
      $func_name = @line[1];
      @t = split(/[ ]/, $func_name);
      $func_name_raw = @t[1];
      $cheader_rule = $cheader_rule."\t\$(PERL_IPE) \$(DEL_FUNC_DECL:X=$func_name) \$@\n";
      $cimpl_rule = $cimpl_rule."\t\$(PERL_IPE) \$(HACK) \$(DEL_FUNC_IMPL:X=$func_name) \$@\n";
      $pintf_rule = $pintf_rule."\t\$(PERL_IPE) \$(DEL_PASL_DECL:X=$func_name_raw) \$@\n";
      $pimpl_rule = $pimpl_rule."\t\$(PERL_IPE) \$(DEL_PASL_IMPL:X=$func_name_raw) \$@\n";

      last SWITCH;
    }
  }
}
