/*************************************************************************** 
                                                                             
 Kylix and Delphi Cross-Platform Visual Component Library                    
                                                                             
 Copyright (c) 2000, 2001 Borland Software Corporation                       
                                                                             
 This file may be distributed and/or modified under the terms of the GNU     
 General Public License (GPL) version 2 as published by the Free Software    
 Software Foundation and appearing at http://www.borland.com/kylix/gpl.html. 
                                                                             
 Licensees holding a valid Borland No-Nonsense License for this Software may 
 use this file in accordance with such license, which appears in the file    
 license.txt that came with this Software.                                   
                                                                             
****************************************************************************/

#ifndef qt_hookH
#define qt_hookH

#include "qtypes.h"

class Qt_hook : public QObject {
  Q_OBJECT
  public:
    Qt_hook(QObject *handle) : QObject(NULL) {
      this->handle = handle;
      this->events.func = NULL;
    }

    virtual ~Qt_hook() {
      if ( handle )
      {
        handle->removeEventFilter( this );
	handle->disconnect( this );
	handle = NULL;
      }
    }

    void hook_events(QHook &hook) {
	if ( !events.func ) {
	  handle->installEventFilter(this);
	  events = hook; }
	if (!hook.func)
	  handle->removeEventFilter(this);
	events = hook;
      }

  protected:
    QObject *handle;
	  virtual bool eventFilter(QObject *sender, QEvent *event) {
	    if ( events.func ) {
		typedef bool (*func_type)(void *data, QObject *sender, QEvent *event);
		return (*(func_type)events.func)(events.data, sender, event);
	    }
	    return false;
	  }

  private:
    QHook events;
};

#endif









